SystemOrganization addCategory: #Spy!
SystemOrganization addCategory: #'Spy-Aspects'!
SystemOrganization addCategory: #'Spy-Services'!

!ClassDescription methodsFor: '*Spy' stamp: 'dgg 11/29/2011 23:22'!
asSWReference
	| ref |
	ref := (SWClassRef new)
				name: self theNonMetaClass name;
				isMeta: self isMeta;
				yourself.
	self isObsolete ifTrue: [ref nonObsolete].
	^ref! !

!PasteUpMorph methodsFor: '*Spy-Services' stamp: 'dgg 11/29/2011 23:25'!
requestor
	^ Requestor default ! !

!CodeHolder methodsFor: '*Spy-Services' stamp: 'dgg 11/29/2011 23:23'!
requestor 
	^ (BrowserRequestor new) browser: self; yourself ! !

PhAspect subclass: #ClassProtocolAspect
	instanceVariableNames: ''
	classVariableNames: 'Unique'
	poolDictionaries: ''
	category: 'Spy-Aspects'!

!ClassProtocolAspect class methodsFor: 'as yet unclassified' stamp: 'dgg 1/17/2012 18:08'!
install
	Unique ifNil: [
		Unique := self new.
		Unique install.].
	! !

!ClassProtocolAspect class methodsFor: 'as yet unclassified' stamp: 'dgg 1/17/2012 18:08'!
uninstall
	Unique isNil ifFalse: [
		Unique uninstall.
		Unique := nil]! !

!ClassProtocolAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/17/2012 18:11'!
addProtocolAddedAdvice
	| pc adv |
	pc := PhPointcut receivers: 'ClassOrganizer' selectors: 'addCategory:before:' context: #(receiver arguments).
	adv := PhAdvice
		after: pc
		send: #logProtocolAdded:
		to: self.
		
	self add: adv.! !

!ClassProtocolAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/17/2012 18:16'!
addProtocolRemovedAdvice
	| pc adv |
	pc := PhPointcut receivers: 'ClassOrganizer' selectors: 'removeCategory:' context: #(receiver arguments).
	adv := PhAdvice
		after: pc
		send: #logProtocolRemoved:
		to: self.
		
	self add: adv.! !

!ClassProtocolAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/17/2012 18:17'!
addProtocolRenamedAdvice
	| pc adv |
	pc := PhPointcut receivers: 'ClassOrganizer' selectors: 'renameCategory:toBe:' context: #(receiver arguments).
	adv := PhAdvice
		after: pc
		send: #logProtocolRenamed:
		to: self.
		
	self add: adv.! !

!ClassProtocolAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/17/2012 18:20'!
initialize
	| pc adv|
	super initialize.
	self addProtocolAddedAdvice.
	self addProtocolRenamedAdvice.
	self addProtocolRemovedAdvice! !

!ClassProtocolAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/17/2012 18:13'!
logProtocolAdded: ctx
	| dict |
	dict := Dictionary new.
	dict at: #class put: (ctx receiver subject name).
	dict at: #protocol put: (ctx arguments at: 1).
	Spy default logEventFromSpec: dict kind: #protocolAdded! !

!ClassProtocolAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/17/2012 18:20'!
logProtocolRemoved: ctx
	| dict |
	dict := Dictionary new.
	dict at: #class put: (ctx receiver subject name).
	dict at: #protocol put: (ctx arguments at: 1).
	Spy default logEventFromSpec: dict kind: #protocolRemoved! !

!ClassProtocolAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/17/2012 18:19'!
logProtocolRenamed: ctx
	| dict |
	dict := Dictionary new.
	dict at: #class put: (ctx receiver subject name).
	dict at: #oldName put: (ctx arguments at: 1).
	dict at: #newName put: (ctx arguments at: 2).
	Spy default logEventFromSpec: dict kind: #protocolRenamed! !

PhAspect subclass: #ClipboardClassAspect
	instanceVariableNames: ''
	classVariableNames: 'Unique'
	poolDictionaries: ''
	category: 'Spy-Aspects'!

!ClipboardClassAspect class methodsFor: 'as yet unclassified' stamp: 'dgg 11/29/2011 23:39'!
install
	Unique ifNil: [
		Unique := self new.
		Unique install.].
	! !

!ClipboardClassAspect class methodsFor: 'as yet unclassified' stamp: 'dgg 11/29/2011 23:40'!
uninstall
	Unique isNil ifFalse: [
		Unique uninstall.
		Unique := nil]! !

!ClipboardClassAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/17/2012 11:39'!
addClipboardCopyPaste
	| copyPastePC adv |
	copyPastePC := PhPointcut receivers: 'Clipboard class' selectors: #('clipboardText:' 'clipboardText') context: #(#arguments #receiver #sender #selector).
	"pastePC := PhPointcut receivers: 'Clipboard class' selectors: 'clipboardText' context: #(#arguments #receiver #sender #selector) if: [:ctx | ctx sender model isKindOf: Browser]."
	adv := PhAdvice
		after: copyPastePC
		send: #copyPaste:
		to: self.
	self add: adv.! !

!ClipboardClassAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/17/2012 11:49'!
copyPaste: ctx
	(ctx sender model isKindOf: OBDefinitionPanel)
		ifTrue: [ ^ self copyPasteForOBrowser: ctx ].
	(ctx sender model isKindOf: Browser)
		ifTrue: [ ^ self copyPasteForBrowser: ctx ].
	self genericCopyPaste: ctx! !

!ClipboardClassAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/18/2012 19:23'!
copyPasteForBrowser: ctx
	| string dict |
	
	dict := Dictionary new.
	dict at: #class put: ctx sender model selectedClassOrMetaClass name.
	dict at: #selector put: ctx sender model selectedMessageName.
	dict at: #browser put: ctx sender model identityHash.
	dict at: #browserType put: ctx sender model class name.
	ctx selector == #clipboardText:
		ifTrue: [ 
			"copy"
			"string := ctx arguments at: 1."
			dict at: #source put: (ctx arguments at: 1) asString.
			Spy default logEventFromSpec: dict kind: #copy.
			"Spy default logCopy: string from: dict" ]
		ifFalse: [ 
			"paste"
			"string := ctx receiver default clipboardText.
			Spy default logPaste: string from: dict"
			dict at: #source put:  (ctx receiver default clipboardText) asString.
			Spy default logEventFromSpec: dict kind: #paste ]! !

!ClipboardClassAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/18/2012 19:24'!
copyPasteForOBrowser: ctx
	| string dict |
	
	dict := Dictionary new.
	dict at: #class put: ctx sender model selectedClassOrMetaClass name.
	((ctx sender model getDefinition) isKindOf: OBMethodDefinition)
		ifTrue: [dict at: #selector put: ctx sender model getDefinition selector]
		ifFalse: [dict at: #selector put: nil].
	dict at: #selector put: ctx sender model getDefinition selector.
	dict at: #browser put: ctx sender model browser identityHash.
	dict at: #browserType put: ctx sender model browser class name.
	ctx selector == #clipboardText:
		ifTrue: [ 
			"copy"
			string := (ctx arguments at: 1) asString.
			dict at: #source put: string.
			Spy default logEventFromSpec: dict kind: #copy: 
			"Spy default logCopy: string from: dict" ]
		ifFalse: [ 
			"paste"
			string := (ctx receiver default clipboardText) asString. 
			dict at: #source put: string.
			Spy default logEventFromSpec: dict kind: #paste. 
			"Spy default logPaste: string from: dict" ]! !

!ClipboardClassAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/18/2012 19:24'!
genericCopyPaste: ctx
	| string dict |
	
	dict := Dictionary new.
	ctx selector == #clipboardText:
		ifTrue: [ 
			"copy"
			"string := ctx arguments at: 1."
			dict at: #source put: (ctx arguments at: 1) asString.
			dict at: #from put: (ctx sender model identityHash asString).
			dict at: #fromClass put: (ctx sender model class name). 
			Spy default logEventFromSpec: dict kind: #copy.
			"Spy default logCopy: string from: dict" ]
		ifFalse: [ 
			"paste"
			"string := ctx receiver default clipboardText.
			Spy default logPaste: string from: dict"
			dict at: #source put:  (ctx receiver default clipboardText) asString.
			dict at: #to put: (ctx sender model identityHash asString).
			dict at: #toClass put: (ctx sender model class name). 
			Spy default logEventFromSpec: dict kind: #paste ]! !

!ClipboardClassAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/17/2012 11:50'!
initialize
	super initialize.
	self addClipboardCopyPaste! !

PhAspect subclass: #DebuggerAspect
	instanceVariableNames: ''
	classVariableNames: 'Unique'
	poolDictionaries: ''
	category: 'Spy-Aspects'!

!DebuggerAspect class methodsFor: 'as yet unclassified' stamp: 'dgg 12/16/2011 02:07'!
install
	Unique ifNil: [
		Unique := self new.
		Unique install.].
	! !

!DebuggerAspect class methodsFor: 'as yet unclassified' stamp: 'dgg 12/16/2011 02:07'!
uninstall
	Unique isNil ifFalse: [
		Unique uninstall.
		Unique := nil]! !

!DebuggerAspect methodsFor: 'as yet unclassified' stamp: 'dgg 12/16/2011 02:38'!
addCreateAdvice
	| pc adv |
	pc := PhPointcut receivers: 'Debugger' selectors: 'createMethod' context: #(receiver).
	adv := PhAdvice
		before: pc
		send: #logCreate:
		to: self.
	self add: adv.! !

!DebuggerAspect methodsFor: 'as yet unclassified' stamp: 'dgg 12/16/2011 02:35'!
addFullStackAdvice
	| pc adv |
	pc := PhPointcut receivers: 'Debugger' selectors: 'fullStack' context: #(receiver).
	adv := PhAdvice
		before: pc
		send: #logFullStack:
		to: self.
	self add: adv.! !

!DebuggerAspect methodsFor: 'as yet unclassified' stamp: 'dgg 12/16/2011 02:32'!
addIntoAdvice
	| pc adv |
	pc := PhPointcut receivers: 'Debugger' selectors: 'send' context: #(receiver).
	adv := PhAdvice
		before: pc
		send: #logInto:
		to: self.
	self add: adv.! !

!DebuggerAspect methodsFor: 'as yet unclassified' stamp: 'dgg 12/16/2011 02:32'!
addOverAdvice
	| pc adv |
	pc := PhPointcut receivers: 'Debugger' selectors: 'doStep' context: #(receiver).
	adv := PhAdvice
		before: pc
		send: #logOver:
		to: self.
	self add: adv.! !

!DebuggerAspect methodsFor: 'as yet unclassified' stamp: 'dgg 12/16/2011 02:27'!
addProceedAdvice
	| pc adv |
	pc := PhPointcut receivers: 'Debugger' selectors: 'proceed' context: #(receiver).
	adv := PhAdvice
		before: pc
		send: #logProceed:
		to: self.
	self add: adv.! !

!DebuggerAspect methodsFor: 'as yet unclassified' stamp: 'dgg 12/16/2011 02:31'!
addRestartAdvice
	| pc adv |
	pc := PhPointcut receivers: 'Debugger' selectors: 'restart' context: #(receiver).
	adv := PhAdvice
		before: pc
		send: #logRestart:
		to: self.
	self add: adv.! !

!DebuggerAspect methodsFor: 'as yet unclassified' stamp: 'dgg 12/16/2011 02:36'!
addRunToHereAdvice
	| pc adv |
	pc := PhPointcut receivers: 'Debugger' selectors: 'runToSelection' context: #(receiver).
	adv := PhAdvice
		before: pc
		send: #logRunToHere:
		to: self.
	self add: adv.! !

!DebuggerAspect methodsFor: 'as yet unclassified' stamp: 'dgg 12/28/2011 19:33'!
addStoreStackAdvice
	| pc adv |
	pc := PhPointcut receivers: 'Debugger' selectors: #('expandStack' 'fullyExpandStack') context: #(receiver).
	adv := PhAdvice
		before: pc
		send: #logStack:
		to: self.
	self add: adv.! !

!DebuggerAspect methodsFor: 'as yet unclassified' stamp: 'dgg 12/16/2011 02:34'!
addThroughAdvice
	| pc adv |
	pc := PhPointcut receivers: 'Debugger' selectors: 'stepIntoBlock' context: #(receiver).
	adv := PhAdvice
		before: pc
		send: #logThrough:
		to: self.
	self add: adv.! !

!DebuggerAspect methodsFor: 'as yet unclassified' stamp: 'dgg 12/16/2011 02:38'!
addWhereAdvice
	| pc adv |
	pc := PhPointcut receivers: 'Debugger' selectors: 'where' context: #(receiver).
	adv := PhAdvice
		before: pc
		send: #logWhere:
		to: self.
	self add: adv.! !

!DebuggerAspect methodsFor: 'as yet unclassified' stamp: 'dgg 12/28/2011 20:44'!
initialize
	| pc adv|
	super initialize.
	self addCreateAdvice.
	self addFullStackAdvice.
	self addIntoAdvice.
	self addOverAdvice.
	self addProceedAdvice.
	self addRestartAdvice.
	self addRunToHereAdvice.
	self addThroughAdvice.
	self addWhereAdvice.
	self addStoreStackAdvice.! !

!DebuggerAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/12/2012 11:27'!
logCreate: ctx
	| dict |
	dict := Dictionary new.
	self setBasicDebuggerInformation: ctx into: dict.
	dict at: #type put: #create.
	Spy default logEventFromSpec: dict kind: #debug.
	"Spy default logDebuggerActionFrom: dict." ! !

!DebuggerAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/12/2012 11:28'!
logFullStack: ctx
	| dict |
	dict := Dictionary new.
	self setBasicDebuggerInformation: ctx into: dict.
	dict at: #type put: #fullStack.
	Spy default logEventFromSpec: dict kind: #debug.
	"Spy default logDebuggerActionFrom: dict. "! !

!DebuggerAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/12/2012 11:29'!
logInto: ctx
	| dict |
	dict := Dictionary new.
	self setBasicDebuggerInformation: ctx into: dict.
	dict at: #type put: #into.
	Spy default logEventFromSpec: dict kind: #debug.
	"Spy default logDebuggerActionFrom: dict. "! !

!DebuggerAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/12/2012 11:29'!
logOver: ctx
	| dict |
	dict := Dictionary new.
	self setBasicDebuggerInformation: ctx into: dict.
	dict at: #type put: #over.
	Spy default logEventFromSpec: dict kind: #debug.
	"Spy default logDebuggerActionFrom: dict. "! !

!DebuggerAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/12/2012 11:29'!
logProceed: ctx
	| dict |
	dict := Dictionary new.
	self setBasicDebuggerInformation: ctx into: dict.
	dict at: #type put: #proceed.
	Spy default logEventFromSpec: dict kind: #debug.
	"Spy default logDebuggerActionFrom: dict. "! !

!DebuggerAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/12/2012 11:30'!
logRestart: ctx
	| dict |
	dict := Dictionary new.
	self setBasicDebuggerInformation: ctx into: dict.
	dict at: #type put: #restart.
	Spy default logEventFromSpec: dict kind: #debug.
	"Spy default logDebuggerActionFrom: dict. "! !

!DebuggerAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/12/2012 11:30'!
logRunToHere: ctx
	| dict |
	dict := Dictionary new.
	self setBasicDebuggerInformation: ctx into: dict.
	dict at: #type put: #runToHere.
	Spy default logEventFromSpec: dict kind: #debug.
	"Spy default logDebuggerActionFrom: dict. "! !

!DebuggerAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/17/2012 14:39'!
logStack: ctx
	| dict |
	dict := Dictionary new.
	self setBasicDebuggerInformation: ctx into: dict.
	dict at: #type put: #stack.
	Spy default logEventFromSpec: dict kind: #debug item: (
		SWStack stack: (ctx receiver instVarNamed: 'contextStack')).
	"dict at: #stack put: (ctx receiver instVarNamed: 'contextStack').
	Spy default logDebuggerStackFrom: dict. "! !

!DebuggerAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/12/2012 11:33'!
logThrough: ctx
	| dict |
	dict := Dictionary new.
	self setBasicDebuggerInformation: ctx into: dict.
	dict at: #type put: #through.
	Spy default logEventFromSpec: dict kind: #debug.
	"Spy default logDebuggerActionFrom: dict. "! !

!DebuggerAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/12/2012 11:34'!
logWhere: ctx
	| dict |
	dict := Dictionary new.
	self setBasicDebuggerInformation: ctx into: dict.
	dict at: #type put: #where.
	Spy default logEventFromSpec: dict kind: #debug.
	"Spy default logDebuggerActionFrom: dict. "! !

!DebuggerAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/17/2012 16:17'!
setBasicDebuggerInformation: ctx into: data
	data at: #class put: ctx receiver selectedClass name asString.
	data at: #selector put: ctx receiver selectedMessageName asString.
	data at: #browser put: ctx receiver identityHash asString.
	data at: #browserType put: ctx receiver class name asString.
	ctx receiver contents size > 0 & (ctx receiver contents size >= ctx receiver contentsSelection last)
		ifTrue: [ data at: #selection put: (ctx receiver contents atAll: ctx receiver contentsSelection) asString ]! !

PhAspect subclass: #DoitAspect
	instanceVariableNames: ''
	classVariableNames: 'Unique'
	poolDictionaries: ''
	category: 'Spy-Aspects'!

!DoitAspect class methodsFor: 'as yet unclassified' stamp: 'dgg 12/15/2011 11:56'!
install
	Unique ifNil: [
		Unique := self new.
		Unique install.].
	! !

!DoitAspect class methodsFor: 'as yet unclassified' stamp: 'dgg 12/15/2011 11:56'!
uninstall
	Unique isNil ifFalse: [
		Unique uninstall.
		Unique := nil]! !

!DoitAspect methodsFor: 'as yet unclassified' stamp: 'dgg 12/15/2011 12:21'!
initialize
	| pc adv|
	super initialize.
	pc := PhPointcut receivers: #('SmalltalkEditor' 'ParagraphEditor' 'TextEditor') selectors: 'evaluateSelectionAndDo:' context: #(sender receiver).
	adv := PhAdvice
		before: pc
		send: #logDoit:
		to: self.
	self add: adv.! !

!DoitAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/12/2012 11:35'!
logDoit: ctx
	| data |
	data := Dictionary new.
	ctx receiver selectLine.
	data at: #source put: (ctx receiver selection asString).
	Spy default logEventFromSpec: data kind: #doit.
	"Spy default logDoitFrom: data."
	! !

PhAspect subclass: #GetSourceAspect
	instanceVariableNames: ''
	classVariableNames: 'Unique'
	poolDictionaries: ''
	category: 'Spy-Aspects'!

!GetSourceAspect class methodsFor: 'as yet unclassified' stamp: 'dgg 12/1/2011 17:37'!
install
	Unique ifNil: [
		Unique := self new.
		Unique install.].
	! !

!GetSourceAspect class methodsFor: 'as yet unclassified' stamp: 'dgg 12/1/2011 17:37'!
uninstall
	Unique isNil ifFalse: [
		Unique uninstall.
		Unique := nil]! !

!GetSourceAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/26/2012 17:58'!
addAdviceForBrowser
	| browserPC adv |
	
	browserPC := PhPointcut receivers: 'Browser' selectors: 'contents' context: #(#receiver) if: [:ctx|
		ctx receiver editSelection == #editMessage].
	
	adv := PhAdvice
		after: browserPC
		send: #logBrowseFromBrowserAdvice:
		to: self.
	
	self add: adv.! !

!GetSourceAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/18/2012 20:11'!
addAdviceForDebugger
	| debuggerPC adv |
	
	debuggerPC := PhPointcut
		receivers: 'Debugger'
		selectors: 'selectedMessage'
		context: #(receiver).
	
	adv := PhAdvice
		after: debuggerPC
		send: #logBrowseFromDebugger:
		to: self.
	
	self add: adv.! !

!GetSourceAspect methodsFor: 'as yet unclassified' stamp: 'dgg 12/1/2011 21:37'!
addAdviceForFinderUI
	| finderUIPC getSourcePC adv |
	
	finderUIPC := PhPointcut
		receivers: 'FinderUI'
		selectors: 'sourceCode'
		context: #(receiver).
		
	getSourcePC := PhPointcut 
	receivers: 'CompiledMethod' 
	selectors: 'getSource' 
	context: #(sender receiver).
	
	adv := PhAdvice
		after: (getSourcePC inCflowOf: finderUIPC)
		send: #logBrowseFromFinderUIAdvice:
		to: self.
	
	self add: adv.! !

!GetSourceAspect methodsFor: 'as yet unclassified' stamp: 'dgg 12/26/2011 19:42'!
addAdviceForOBBrowser
	| oBBrowserPC adv |
	
	oBBrowserPC := PhPointcut
		receivers: 'OBDefinitionPanel'
		selectors: 'definitionChanged:'
		context: #(receiver)
		if: [:ctx | ctx receiver getDefinition isKindOf: OBMethodDefinition].
	
	adv := PhAdvice
		after: oBBrowserPC
		send: #logBrowseFromOBBrowserAdvice:
		to: self.
	
	self add: adv.! !

!GetSourceAspect methodsFor: 'as yet unclassified' stamp: 'dgg 12/1/2011 21:44'!
initialize
	super initialize.
	self addAdviceForBrowser.
	self addAdviceForDebugger.
	self addAdviceForFinderUI.
	self addAdviceForOBBrowser.
	! !

!GetSourceAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/12/2012 11:38'!
logBrowseFromBrowserAdvice: ctx
	| dict |
	ctx receiver selectedClassOrMetaClass ifNil: [^nil].
	dict := Dictionary new.
	dict at: #class put: ctx receiver selectedClassOrMetaClass name.
	dict at: #selector put: ctx receiver selectedMessageName.
	dict at: #browser put: ctx receiver identityHash.
	dict at: #browserType put: ctx receiver class name.
	Spy default logEventFromSpec: dict kind: #navigate
	"Spy default logNavigationFrom: dict."! !

!GetSourceAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/18/2012 20:08'!
logBrowseFromDebugger: ctx
	| dict |
	dict := Dictionary new.
	dict at: #class put: ctx receiver selectedClass name.
	dict at: #selector put: ctx receiver selectedMessageName.
	dict at: #browser put: ctx receiver identityHash.
	dict at: #browserType put: ctx receiver class name.
	"dict at: #selection put: ((ctx receiver contents atAll: (ctx receiver contentsSelection)) asString)."
	ctx receiver contents size > 0 & (ctx receiver contents size >= ctx receiver contentsSelection last)
		ifTrue: [ dict at: #selection put: (ctx receiver contents atAll: ctx receiver contentsSelection) asString ].
	Spy default logEventFromSpec: dict kind: #navigate.
	"Spy default logNavigationFrom: dict."
	! !

!GetSourceAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/12/2012 11:39'!
logBrowseFromFinderUIAdvice: ctx
	| dict |
	dict := Dictionary new.
	dict at: #class put: ctx receiver methodClass name.
	dict at: #selector put: ctx receiver selector.
	dict at: #browser put: ctx sender identityHash.
	dict at: #browserType put: ctx sender class name.
	Spy default logEventFromSpec: dict kind: #navigate 
	"Spy default logNavigationFrom: dict."! !

!GetSourceAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/12/2012 11:39'!
logBrowseFromOBBrowserAdvice: ctx
	| dict |
	ctx receiver getDefinition theClass ifNil: [^nil].
	dict := Dictionary new.
	dict at: #class put: ctx receiver getDefinition theClass name.
	dict at: #selector put: ctx receiver getDefinition selector.
	dict at: #browser put: ctx receiver browser identityHash.
	dict at: #browserType put: ctx receiver browser class name.
	Spy default logEventFromSpec: dict kind: #navigate
	"Transcript show: 'sender: ', ctx sender class asString; cr."
	"Spy default logNavigationFrom: dict."! !

PhAspect subclass: #InspectVariablesAspect
	instanceVariableNames: ''
	classVariableNames: 'Unique'
	poolDictionaries: ''
	category: 'Spy-Aspects'!

!InspectVariablesAspect class methodsFor: 'as yet unclassified' stamp: 'dgg 12/15/2011 13:06'!
install
	Unique ifNil: [
		Unique := self new.
		Unique install.].
	! !

!InspectVariablesAspect class methodsFor: 'as yet unclassified' stamp: 'dgg 12/15/2011 13:06'!
uninstall
	Unique isNil ifFalse: [
		Unique uninstall.
		Unique := nil]! !

!InspectVariablesAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/20/2012 12:03'!
addInspectVariableAspect
	| pc adv|
	pc := PhPointcut receivers: #('Inspector') selectors: 'toggleIndex:' context: #(receiver).
	adv := PhAdvice
		after: pc
		send: #logInspectVariables:
		to: self.
	self add: adv.! !

!InspectVariablesAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/20/2012 12:22'!
addInspectorCreation
	| pc adv|
	pc := PhPointcut receivers: 'Inspector class+' selectors: 'inspect:' context: #(sender receiver proceed).
	adv := PhAdvice
		around: pc
		send: #logInspectorCreation:
		to: self.
	self add: adv.! !

!InspectVariablesAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/20/2012 12:12'!
initialize
	super initialize.
	self addInspectVariableAspect.
	self addInspectorCreation! !

!InspectVariablesAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/24/2012 13:27'!
logInspectVariables: ctx
	| data |
	data := Dictionary new.
	data at: #type put: #inspectVariable.
	data at: #inspector put: (ctx receiver identityHash asString).
	data at: #inspectorClass put: (ctx receiver class name).
	data at: #variableName put: (ctx receiver selectedSlotName asString).
	data at: #contents put: (ctx receiver contents asString).
	"Spy default logInspectVariablesFrom:  data."
	Spy default logEventFromSpec: data kind: #inspect
	! !

!InspectVariablesAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/24/2012 13:28'!
logInspectorCreation: ctx
	| data inspector |
	data := Dictionary new.
	inspector := ctx proceed.
	data at: #type put: #inspectorCreation.
	data at: #inspectorClass put: (ctx receiver asString).
	data at: #inspector put: (inspector identityHash).
	(ctx sender isKindOf: Debugger)
		ifTrue: [data at: #debugger put: (ctx sender identityHash)].
	Spy default logEventFromSpec: data kind: #inspect.
	^ inspector ! !

PhAspect subclass: #KeyboardActivityAspect
	instanceVariableNames: ''
	classVariableNames: 'Unique'
	poolDictionaries: ''
	category: 'Spy-Aspects'!

!KeyboardActivityAspect class methodsFor: 'as yet unclassified' stamp: 'dgg 12/28/2011 01:08'!
install
	Unique ifNil: [
		Unique := self new.
		Unique install.].
	! !

!KeyboardActivityAspect class methodsFor: 'as yet unclassified' stamp: 'dgg 12/28/2011 01:08'!
uninstall
	Unique isNil ifFalse: [
		Unique uninstall.
		Unique := nil]! !

!KeyboardActivityAspect methodsFor: 'as yet unclassified' stamp: 'dgg 12/28/2011 01:09'!
initialize
	| pc adv |
	super initialize.
	pc := PhPointcut
		receivers: 'KeyboardEvent'
		selectors: 'scanCode:'
		context: #(#receiver #arguments)
		if: [ :ctx | ctx receiver isKeystroke ].
	adv := PhAdvice before: pc send: #logKeyboardEvent: to: self.
	self add: adv! !

!KeyboardActivityAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/17/2012 12:03'!
logKeyboardEvent: ctx
	| data |
	data := Dictionary new.
	data at: #keyValue put: (ctx receiver keyValue).
	data at: #commandKey put: (ctx receiver commandKeyPressed).
	data at: #shift put: (ctx receiver shiftPressed).
	data at: #control put: (ctx receiver controlKeyPressed).
	"Spy default logKeyboardEventFrom: data."
	Spy default logEventFromSpec: data kind: #keyboard
	! !

PhAspect subclass: #MCRepositoryAspect
	instanceVariableNames: ''
	classVariableNames: 'Unique'
	poolDictionaries: ''
	category: 'Spy-Aspects'!

!MCRepositoryAspect class methodsFor: 'as yet unclassified' stamp: 'dgg 11/29/2011 23:40'!
install
	Unique ifNil: [
		Unique := self new.
		Unique install.].
	! !

!MCRepositoryAspect class methodsFor: 'as yet unclassified' stamp: 'dgg 11/29/2011 23:41'!
uninstall
	Unique isNil ifFalse: [
		Unique uninstall.
		Unique := nil]! !

!MCRepositoryAspect methodsFor: 'as yet unclassified' stamp: 'dgg 11/29/2011 21:10'!
initialize
	| pc adv |
	super initialize.
	pc := PhPointcut receivers: 'MCRepository' selectors: 'storeVersion:' context: #(arguments).
	adv := PhAdvice
		after: pc
		send: #storeVersionAdv:
		to: self.
	self add: adv.! !

!MCRepositoryAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/11/2012 01:34'!
storeVersionAdv: ctx
	| aVersion data |
	aVersion := ctx arguments at: 1.
	data := Dictionary new.
	aVersion
		ifNotNil: [ 
			data at: #summary put: aVersion summary.
			data at: #package put: aVersion package name.
			data at: #definitions put: aVersion snapshot definitions size ].	
	"Spy default logVersionSave: aVersion"
	Spy default logEventFromSpec: data kind: #versionSave! !

PhAspect subclass: #MCVersionLoaderClassAspect
	instanceVariableNames: ''
	classVariableNames: 'Unique'
	poolDictionaries: ''
	category: 'Spy-Aspects'!

!MCVersionLoaderClassAspect class methodsFor: 'as yet unclassified' stamp: 'dgg 11/29/2011 23:40'!
install
	Unique ifNil: [
		Unique := self new.
		Unique install.].
	! !

!MCVersionLoaderClassAspect class methodsFor: 'as yet unclassified' stamp: 'dgg 11/29/2011 23:41'!
uninstall
	Unique isNil ifFalse: [
		Unique uninstall.
		Unique := nil]! !

!MCVersionLoaderClassAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/11/2012 01:38'!
endLoadAdvice: ctx
	| data version |
	data := Dictionary new.
	version := (ctx arguments at: 1).
	data at: #package put: version package name.
	Spy default logEventFromSpec: data kind: #versionLoadEnd
	"Spy default logVersionLoadEnd: (ctx arguments at: 1)"! !

!MCVersionLoaderClassAspect methodsFor: 'as yet unclassified' stamp: 'dgg 11/29/2011 21:17'!
initialize
	| pc beforeAdv afterAdv |
	super initialize.
	pc := PhPointcut receivers: 'MCVersionLoader class' selectors: 'loadVersion:' context: #(arguments).
	beforeAdv := PhAdvice
		before: pc
		send: #startLoadAdvice:
		to: self.
	afterAdv := PhAdvice
		after: pc
		send: #endLoadAdvice:
		to: self.
	self add: beforeAdv.
	self add: afterAdv.! !

!MCVersionLoaderClassAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/11/2012 01:38'!
startLoadAdvice: ctx
	| data version |
	data := Dictionary new.
	version := (ctx arguments at: 1).
	data at: #package put: version package name.
	Spy default logEventFromSpec: data kind: #versionLoadStart
	"Spy default logVersionLoadStart: (ctx arguments at: 1)."! !

PhAspect subclass: #MCWorkingCopyBrowserAspect
	instanceVariableNames: ''
	classVariableNames: 'Unique'
	poolDictionaries: ''
	category: 'Spy-Aspects'!

!MCWorkingCopyBrowserAspect class methodsFor: 'as yet unclassified' stamp: 'dgg 11/29/2011 23:40'!
install
	Unique ifNil: [
		Unique := self new.
		Unique install.].
	! !

!MCWorkingCopyBrowserAspect class methodsFor: 'as yet unclassified' stamp: 'dgg 11/29/2011 23:41'!
uninstall
	Unique isNil ifFalse: [
		Unique uninstall.
		Unique := nil]! !

!MCWorkingCopyBrowserAspect methodsFor: 'as yet unclassified' stamp: 'dgg 11/29/2011 21:45'!
initialize
	| pc cflow adv |
	super initialize.
	cflow := PhPointcut receivers: 'MCWorkingCopyBrowser' selectors: 'saveVersion'.
	pc := PhPointcut receivers: 'MCWorkingCopy' selectors: 'newVersion' context: #(proceed).
	adv := PhAdvice
		around: (pc inCflowOf: cflow)
		send: #saveVersionAdv:
		to: self.
	self add: adv.! !

!MCWorkingCopyBrowserAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/11/2012 01:42'!
saveVersionAdv: ctx
	| data version |
	version := ctx proceed.
	version ifNotNilDo: [:v |
		data := Dictionary new.
		data at: #summary put: version summary.
		data at: #package put: version package name.
		data at: #definitions put: version snapshot definitions size.
		Spy default logEventFromSpec: data kind: #versionSave].
	^ version
	"| version |
	version := ctx proceed.
	version ifNotNilDo: [:v |
		Spy default logVersionSave: v].
	^ version."
		! !

PhAspect subclass: #MenuAspect
	instanceVariableNames: ''
	classVariableNames: 'Unique'
	poolDictionaries: ''
	category: 'Spy-Aspects'!

!MenuAspect class methodsFor: 'as yet unclassified' stamp: 'dgg 1/1/2012 23:53'!
install
	Unique ifNil: [
		Unique := self new.
		Unique install.].
	! !

!MenuAspect class methodsFor: 'as yet unclassified' stamp: 'dgg 1/1/2012 23:53'!
uninstall
	Unique isNil ifFalse: [
		Unique uninstall.
		Unique := nil]! !

!MenuAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/2/2012 00:34'!
addMenuActionAdvice
	| pc adv |
	pc := PhPointcut receivers: 'MenuItemMorph' selectors: 'invokeWithEvent:' context: #(receiver) if: [:ctx |
		self verifyEnabledMenuAction: ctx receiver].
	adv := PhAdvice
		before: pc
		send: #logMenuAction:
		to: self.
		
	self add: adv.! !

!MenuAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/8/2012 02:04'!
addMenuOpenAdvice
	| pc adv parser |
	parser := (('popUpOwner' asParser, $: asParser optional) end not),( 'popUp' asParser, #any asParser star) / ('invoke' asParser, #any asParser star).
	pc := PhPointcut receivers: 'MenuMorph' selectors: parser context: #(receiver sender) if: [:ctx |
			ctx sender ~= ctx receiver].
	adv := PhAdvice
		before: pc
		send: #logMenuOpen:
		to: self.
		
	self add: adv.! !

!MenuAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/8/2012 02:28'!
addMenuSelectionAdvice
	| pc adv |
	pc := PhPointcut receivers: 'MenuMorph' selectors: 'selectItem:event:' context: #(receiver sender) if: [:ctx | ctx receiver selectedItem notNil].
	adv := PhAdvice
		after: pc
		send: #logMenuSelection:
		to: self.
	self add: adv.! !

!MenuAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/8/2012 02:09'!
findMenuOrigin: aSender
	^ (aSender isKindOf: ToggleMenuItemMorph)
		ifTrue: [aSender owner]
		ifFalse: [(aSender respondsTo: #model) & (aSender model notNil)
			ifTrue: [(aSender model respondsTo: #browser)
				ifTrue: [aSender model browser]
				ifFalse: [aSender model]]
			ifFalse: [aSender]]! !

!MenuAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/2/2012 01:34'!
initialize
	| pc adv|
	super initialize.
	self addMenuSelectionAdvice.
	self addMenuActionAdvice.
	self addMenuOpenAdvice.! !

!MenuAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/24/2012 11:58'!
logMenuAction: ctx
	| data |
	data := Dictionary new.
	data at: #menu put: (ctx receiver owner identityHash asString).
	data at: #type put: #action.
	data at: #action put: (ctx receiver selector asString).
	data at: #arguments put: (ctx receiver arguments asString).
	data at: #target put: (ctx receiver target asString).
	Spy default logEventFromSpec: data kind: #menu.
	"Spy default logMenuAction: data."
	"Transcript show: 'Menu action triggered'; cr.
	Transcript show: Character tab asString, ' action: ', ctx receiver selector asString; cr.
	Transcript show: Character tab asString, ' on: ', ctx receiver target asString; cr."! !

!MenuAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/24/2012 11:59'!
logMenuOpen: ctx
	| data |
	data := Dictionary new.
	data at: #menu put: (ctx receiver identityHash asString).
	data at: #type put: #open.
	self setMenuOriginData: data from: ctx.
	Spy default logEventFromSpec: data kind: #menu 
	"Spy default logMenuOpen: data."
	"Transcript show: 'Menu action triggered'; cr.
	Transcript show: Character tab asString, ' action: ', ctx receiver selector asString; cr.
	Transcript show: Character tab asString, ' on: ', ctx receiver target asString; cr."! !

!MenuAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/24/2012 12:00'!
logMenuSelection: ctx
	| data source |
	data := Dictionary new.
	data at: #menu put: (ctx receiver identityHash asString).
	data at: #type put: #selection.
	data at: #selectedItem put: (ctx receiver selectedItem  contents asString).
	self setMenuOriginData: data from: ctx.
	Spy default logEventFromSpec: data kind: #menu 
	
	"Spy default logMenuSelection: data."
	
	"Transcript show: 'item selected';cr.
	Transcript show: Character tab asString, ' from: ', (self findMenuOrigin: ctx receiver) asString; cr.
	Transcript show: Character tab asString, ' selected: ', (ctx receiver selectedItem contents); cr."! !

!MenuAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/24/2012 12:01'!
setMenuOriginData: data from: ctx
	| source |
	
	source := self findMenuOrigin: ctx sender.
	data at: #source put: (source identityHash asString).
	data at: #sourceClass put: (source class asString).! !

!MenuAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/2/2012 00:24'!
verifyEnabledMenuAction: aMenuItem
	aMenuItem isEnabled ifFalse: [^false].
	aMenuItem target class == HandMorph ifTrue: [(aMenuItem notObsolete) ifFalse: [^ false]].
	^ true.! !

PhAspect subclass: #UnhandledErrorAspect
	instanceVariableNames: ''
	classVariableNames: 'Unique'
	poolDictionaries: ''
	category: 'Spy-Aspects'!

!UnhandledErrorAspect class methodsFor: 'as yet unclassified' stamp: 'dgg 11/29/2011 23:40'!
install
	Unique ifNil: [
		Unique := self new.
		Unique install.].
	! !

!UnhandledErrorAspect class methodsFor: 'as yet unclassified' stamp: 'dgg 11/29/2011 23:41'!
uninstall
	Unique isNil ifFalse: [
		Unique uninstall.
		Unique := nil]! !

!UnhandledErrorAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/11/2012 02:02'!
defaultActionAdvice: ctx
	| data |
	[ 
	data := Dictionary new.
	data at: #type put: ctx receiver exception class name.
	data at: #message put: ctx receiver exception messageText.
	Spy default logEventFromSpec: data kind: #error ]
		on: Error
		do: [ :e | 
			Transcript
				cr;
				show: e asString;
				show: ' when handling: ';
				show: ctx receiver asString ]	"Spy default logErrorFrom: ctx receiver exception"! !

!UnhandledErrorAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/11/2012 01:55'!
initialize
	| pc adv |
	super initialize.
	pc := PhPointcut receivers: 'UnhandledError' selectors: 'defaultAction' context: #(receiver) if: [:ctx | ctx receiver isKindOf: Exception].
	adv := PhAdvice
		before: pc
		send: #defaultActionAdvice:
		to: self.
	self add: adv.! !

PhAspect subclass: #WindowEventsAspect
	instanceVariableNames: ''
	classVariableNames: 'Unique'
	poolDictionaries: ''
	category: 'Spy-Aspects'!

!WindowEventsAspect class methodsFor: 'as yet unclassified' stamp: 'dgg 12/15/2011 15:01'!
install
	Unique ifNil: [
		Unique := self new.
		Unique install.].
	! !

!WindowEventsAspect class methodsFor: 'as yet unclassified' stamp: 'dgg 12/15/2011 15:01'!
uninstall
	Unique isNil ifFalse: [
		Unique uninstall.
		Unique := nil]! !

!WindowEventsAspect methodsFor: 'as yet unclassified' stamp: 'dgg 12/26/2011 20:28'!
addWindowExtentAdvice
	| pc adv |
	pc := PhPointcut receivers: #('SystemWindow+') selectors: 'extent:' context: #(receiver).
	adv := PhAdvice
		after: pc
		send: #logWindowExtent:
		to: self.
	self add: adv.! !

!WindowEventsAspect methodsFor: 'as yet unclassified' stamp: 'dgg 12/26/2011 20:29'!
addWindowFocusAdvice
	| pc adv |
	pc := PhPointcut receivers: 'SystemWindow+' selectors: 'activate' context: #(receiver).
	adv := PhAdvice
		after: pc
		send: #logWindowFocus:
		to: self.
	self add: adv.! !

!WindowEventsAspect methodsFor: 'as yet unclassified' stamp: 'dgg 12/26/2011 20:28'!
addWindowPositionAdvice
	| pc adv |
	pc := PhPointcut receivers: #('SystemWindow+') selectors: 'position:' context: #(receiver).
	adv := PhAdvice
		after: pc
		send: #logWindowPosition:
		to: self.
	self add: adv.! !

!WindowEventsAspect methodsFor: 'as yet unclassified' stamp: 'dgg 12/26/2011 20:32'!
initialize
	| positionPC extentPC positionADV extentADV|
	super initialize.
	self addWindowFocusAdvice.
	self addWindowPositionAdvice.
	self addWindowExtentAdvice.! !

!WindowEventsAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/26/2012 18:25'!
logWindowExtent: ctx
	| data |
	data := Dictionary new.
	data at: #windowType put: (ctx receiver class name asString).
	data at: #window put: (ctx receiver identityHash).
	data at: #position put: ctx receiver position x asString , '@' , ctx receiver position y asString.
	data at: #extent put: ctx receiver extent x asString , '@' , ctx receiver extent y asString.
	Spy default logEventFromSpec: data kind: #extent.
	"Spy default logWindowExtentFrom: data."! !

!WindowEventsAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/26/2012 18:25'!
logWindowFocus: ctx
	| data |
	data := Dictionary new.
	data at: #windowType put: (ctx receiver class name asString).
	data at: #window put: (ctx receiver identityHash).
	data at: #position put: ctx receiver position x asString , '@' , ctx receiver position y asString.
	data at: #extent put: ctx receiver extent x asString , '@' , ctx receiver extent y asString.
	Spy default logEventFromSpec: data kind: #focus.
	"Spy default logWindowFocusFrom: data."! !

!WindowEventsAspect methodsFor: 'as yet unclassified' stamp: 'dgg 1/26/2012 18:24'!
logWindowPosition: ctx
	| data |
	data := Dictionary new.
	data at: #windowType put: ctx receiver class name asString.
	data at: #window put: ctx receiver identityHash.
	data at: #position put: ctx receiver position x asString , '@' , ctx receiver position y asString.
	data at: #extent put: ctx receiver extent x asString , '@' , ctx receiver extent y asString.
	Spy default logEventFromSpec: data kind: #position	"Spy default logWindowPositionFrom: data."! !

!String methodsFor: '*Spy' stamp: 'dgg 11/29/2011 23:26'!
asSWReference
	| ref |
	
	ref := SWMethodRef new.
	ref inClass: (self copyUpTo: Character space) asSymbol.
	ref name: (self copyAfter: Character space) asSymbol.
	ref isMeta: false.
	^ ref ! !

!Morph methodsFor: '*Spy-Services' stamp: 'dgg 11/29/2011 23:25'!
requestor 
	^ owner ifNil: [super requestor] ifNotNil: [owner requestor ]! !

!StringHolder methodsFor: '*Spy-Services' stamp: 'dgg 11/29/2011 23:26'!
requestor
	
	^ (TextRequestor new) model: self; yourself ! !

!SystemOrganizer methodsFor: '*spy' stamp: 'dgg 1/16/2012 16:51'!
addCategory: catString before: nextCategory
	| r |
	r := super addCategory: catString before: nextCategory.
	SystemChangeNotifier uniqueInstance classCategoryAdded: catString.
	^ r! !

!Trait methodsFor: '*Spy' stamp: 'dgg 11/29/2011 23:28'!
asSWReference
	| ref |
	ref := (SWClassRef new)
				name: self theNonMetaClass name;
				isMeta: self isMeta;
				yourself.
	self isObsolete ifTrue: [ref nonObsolete].
	^ref! !

!Symbol methodsFor: '*Spy' stamp: 'dgg 11/29/2011 23:27'!
asSWReference
	| ref |
	ref := SWClassRef new.
	ref name: self.
	ref isMeta: false.
	^ ref! !

!AbstractEvent methodsFor: '*Spy' stamp: 'dgg 11/29/2011 23:21'!
copyForLongTermStorage
	| newEvent |
	newEvent := self copy.
	newEvent environmentForLongTermStorage: environment.
	^ newEvent! !

!AbstractEvent methodsFor: '*Spy' stamp: 'dgg 11/29/2011 23:21'!
environment
	^ environment! !

!AbstractEvent methodsFor: '*Spy' stamp: 'dgg 11/29/2011 23:21'!
environmentForLongTermStorage: env 
	environment := env copy.
	self itemRequestor: nil! !

!AbstractEvent methodsFor: '*Spy' stamp: 'dgg 11/29/2011 23:21'!
itemReference
	^item isCompiledMethod 
		ifTrue: 
			[self itemClass asSWReference methodReferenceFor: self itemSelector]
		ifFalse: [item asSWReference]! !

!ClassTrait methodsFor: '*Spy' stamp: 'dgg 11/29/2011 23:22'!
asSWReference
	| ref |
	ref := (SWClassRef new)
				name: self theNonMetaClass name;
				isMeta: self isMeta;
				yourself.
	^ref! !

ProtoObject subclass: #OBBrowserRequestor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spy'!

!OBBrowserRequestor methodsFor: 'request' stamp: 'rr 2/12/2009 22:25'!
getClass
	| n |
	n := self getBrowser currentNode.
	n isNil ifTrue: [^ nil].
	n isMethodNode ifTrue: [n := n classNode].
	n isClassNode ifTrue: [^ n theClass].
	^ nil! !

!OBBrowserRequestor methodsFor: 'request' stamp: 'rr 2/12/2009 21:48'!
getClassNameOrNil
	^ self getClass ifNotNilDo: [:cls | cls name]! !

!OBBrowserRequestor methodsFor: 'request' stamp: 'rr 2/12/2009 22:25'!
getSelector
	| n |
	n := self getBrowser currentNode.
	n isNil ifTrue: [^ nil].
	^ n isMethodNode ifTrue: [n selector] ifFalse: [nil]! !

!OBBrowserRequestor methodsFor: 'request' stamp: 'rr 2/12/2009 21:49'!
getSelectorOrNil
	^ self getSelector! !

!OBBrowserRequestor methodsFor: 'request' stamp: 'rr 2/12/2009 21:39'!
getSystemCategory
	| n |
	n := self getBrowser currentNode.
	n isMethodNode ifTrue: [n := n classNode].
	n isClassNode ifTrue: [n := n categoryNode].
	n isCategoryNode ifTrue: [^ n name].
	^ nil! !

!MethodReference methodsFor: '*Spy' stamp: 'dgg 11/29/2011 23:24'!
asSWReference
	| ref |
	ref := SWMethodRef new.
	ref name: methodSymbol.
	ref inClass: classSymbol.
	ref isMeta: classIsMeta.
	^ref! !

!MethodReference methodsFor: '*Spy' stamp: 'dgg 11/29/2011 23:24'!
entityName
	^ "self actualClass name asSymbol , #'>>' , "methodSymbol! !

!SystemWindow methodsFor: '*Spy-Services' stamp: 'dgg 11/29/2011 23:27'!
requestor 
	[^ model requestor ]
		on: Error do: [self isThisEverCalled. ^ Requestor default ] ! !

Object subclass: #BasicRequestor
	instanceVariableNames: 'caption answer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spy-Services'!

!BasicRequestor commentStamp: 'rr 7/10/2006 14:44' prior: 0!
This class is the root of the Requestor hierarchy.

Requestors are interfaces between services and the system. ServiceActions are given an instance
of a Requestor, and they ask it for the data they need. The requestor is determined by the model of the application. A class used as a model can implement the #requestor message to return the most suited requestor. A requestor knows how to query its model and the user if needed.

Requestor are defined in hierarchies so that the protocol they rely on (methods starting with 'get') can be easily reused.!

!BasicRequestor methodsFor: 'generic requests' stamp: 'rr 6/1/2004 21:50'!
caption: aString
	caption := aString! !

!BasicRequestor methodsFor: 'executing' stamp: 'rr 5/31/2004 22:43'!
get: aString
	self caption: aString.
	^ self getSymbol! !

!BasicRequestor methodsFor: 'generic requests' stamp: 'DamienCassou 9/29/2009 09:02'!
getString
	| result |
	result := UIManager default  request:caption initialAnswer: answer contents.
	self newCaption.
	result isEmptyOrNil ifTrue:[ServiceCancelled signal].
	^ result! !

!BasicRequestor methodsFor: 'generic requests' stamp: 'rr 5/31/2004 22:18'!
getStringCollection
	caption := caption, Character cr asString, 'Separate items with space'.
	^ (self getString findTokens: ' ') collect: [:each | each copyWithoutAll: ' ' ]! !

!BasicRequestor methodsFor: 'generic requests' stamp: 'rr 5/31/2004 22:19'!
getSymbol
	^ self getString asSymbol! !

!BasicRequestor methodsFor: 'generic requests' stamp: 'rr 5/31/2004 22:20'!
getSymbolCollection
	^[self getStringCollection collect: [:each | each asSymbol]] 
		on: ServiceCancelled
		do: [#()]! !

!BasicRequestor methodsFor: 'initialization' stamp: 'alain.plantec 5/28/2009 09:42'!
initialize
	super initialize.
	self newCaption! !

!BasicRequestor methodsFor: 'generic requests' stamp: 'PeterHugossonMiller 9/3/2009 00:12'!
newCaption
	caption := 'Enter text'.
	answer := String new writeStream.! !

BasicRequestor subclass: #Requestor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spy-Services'!

!Requestor commentStamp: 'rr 7/10/2006 15:19' prior: 0!
I am an implementation of BasicRequestor with some requests already implemented.!

!Requestor class methodsFor: 'as yet unclassified' stamp: 'rr 3/23/2004 14:32'!
default
	"returns a default requestor"
	^ self new! !

!Requestor methodsFor: 'requests' stamp: 'rr 8/2/2005 14:53'!
getClass
	^Smalltalk at: self getSymbol! !

!Requestor methodsFor: 'requests' stamp: 'rr 5/31/2004 22:03'!
getClassCollection
	^ self getSymbolCollection collect: [:className | Smalltalk at: className]! !

!Requestor methodsFor: 'requests' stamp: 'alain.plantec 2/6/2009 17:56'!
getMethodBody
	^ UIManager default 
			multiLineRequest: 'Please enter the full body of the method you want to define' translated
			centerAt: 0@0 
			initialAnswer: '' 
			answerHeight: 300.
! !

!Requestor methodsFor: 'requests' stamp: 'alain.plantec 2/6/2009 18:01'!
getSelection
	"Sorry to feedle with fillInTheBlankMorph innards, but I had to"
	| text |
	text := (MethodReference class: self getClass selector: self getSelector) sourceCode.
	^ UIManager default 
			multiLineRequest: 'Clean out the source code and accept' translated
			centerAt: 0@0 
			initialAnswer: text
			answerHeight: 300.
! !

!Requestor methodsFor: 'services requests' stamp: 'rr 1/9/2006 11:59'!
getSelector
	^ self caption: 'enter selector'; getSymbol! !

Requestor subclass: #TextRequestor
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spy-Services'!

!TextRequestor commentStamp: 'rr 7/10/2006 15:20' prior: 0!
A requestor for text areas, able for example to fetch the current selected text.!

TextRequestor subclass: #BrowserRequestor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spy-Services'!

!BrowserRequestor commentStamp: 'rr 7/10/2006 15:24' prior: 0!
I am a requestor specialized to fetch information in a Browser.
I can ask a browser its selected class and selected method for example.
If the RB is installed too, I can also fetch ast nodes in the browser's selected
method.

I am the default requestor for CodeHolder and it's subclasses.

To be integrated with services, alternative browsers, such as the OmniBrowser and Whisker should define a specialized requestor subclassing this one. A few core messages would need to be redefined, such as getClass, getMessage ... to be adapted to the browser's data structures. 
Only a few of them have to be overridden, the majority of the requests rely on a few base ones.!

!BrowserRequestor methodsFor: 'initialization' stamp: 'rr 8/27/2005 15:52'!
browser: b
	self model: b! !

!BrowserRequestor methodsFor: 'requests' stamp: 'gvc 9/26/2008 15:14'!
getArgumentPermutation
	"Answer the argument permutation map.
	No support for changing argument count."
	
	^(1 to: (self getBrowser selectedMessageName ifNil: [^nil]) numArgs) asArray! !

!BrowserRequestor methodsFor: 'requests' stamp: 'rr 8/27/2005 15:43'!
getBrowser
	^ self getModel! !

!BrowserRequestor methodsFor: '*Spy' stamp: 'rr 11/30/2006 19:16'!
getBrowserId
	^ self getModel identityHash! !

!BrowserRequestor methodsFor: 'requests' stamp: 'rr 8/27/2005 15:51'!
getClass
	^ self getBrowser selectedClassOrMetaClass! !

!BrowserRequestor methodsFor: '*Spy' stamp: 'rr 2/12/2009 13:04'!
getClassNameOrNil
	^ (self getBrowser selectedClassOrMetaClass) ifNotNilDo: [:cls | cls name]! !

!BrowserRequestor methodsFor: 'requests' stamp: 'alain.plantec 2/6/2009 15:18'!
getInitializingExpressionForTheNewParameter
	^ UIManager default request: 'Enter default parameter code' translated initialAnswer: '42'! !

!BrowserRequestor methodsFor: 'requests' stamp: 'alain.plantec 2/6/2009 15:18'!
getNewSelectorName
	^ UIManager default  request: 'Enter the new selector name' translated initialAnswer: self getSelector! !

!BrowserRequestor methodsFor: 'requests' stamp: 'alain.plantec 2/6/2009 15:18'!
getNewVariableName
	^ UIManager default request: 'Enter the new variable name' translated initialAnswer: 'foo'! !

!BrowserRequestor methodsFor: 'requests' stamp: 'rr 8/4/2005 14:41'!
getPackage
	self getSelector ifNil: [
			^ PackageInfo named:(
					self getClass ifNil: [self getSystemCategory] 
									ifNotNilDo: [:c | c category copyUpTo:  $-])].
	^ PackageOrganizer default 
			packageOfMethod: 
					(MethodReference class: self getClass
										selector: self getSelector)
			ifNone: [PackageInfo named: (self getClass category copyUpTo:  $-)] ! !

!BrowserRequestor methodsFor: 'requests' stamp: 'rr 5/31/2004 22:10'!
getPackageForCategory
	"answers a packageinfo for the current class category"
	^ PackageInfo named: self getClass theNonMetaClass category! !

!BrowserRequestor methodsFor: 'requests' stamp: 'rr 5/31/2004 22:10'!
getPackageForCategoryName
	"answers a packageinfo for the current class category"
	^  self getPackageForCategory packageName! !

!BrowserRequestor methodsFor: 'requests' stamp: 'rr 5/31/2004 22:10'!
getPackageName
	^ self getPackage packageName! !

!BrowserRequestor methodsFor: 'requests' stamp: 'rr 1/9/2006 19:27'!
getPackageProvider
	| provs classes |
	provs := ServiceProvider registeredProviders.
	classes := self getPackage classes.
	^ classes detect: [:e | provs includes: e] ifNone: [ServiceProvider newProviderFor: self getPackageName]! !

!BrowserRequestor methodsFor: 'requests' stamp: 'rr 8/27/2005 15:52'!
getSelection
	self getBrowser selectedInterval ifEmpty: [^super getSelection].
	^ self getBrowser selectedInterval! !

!BrowserRequestor methodsFor: 'requests' stamp: 'rr 1/9/2006 11:58'!
getSelector
	| s |
	s := self getBrowser selectedMessageName.
	^ s ifNil: [super getSelector] ifNotNil: [s]! !

!BrowserRequestor methodsFor: 'requests' stamp: 'rr 10/11/2005 15:06'!
getSelectorCollection
	self caption: 'enter selector list'.
	^ self getSymbolCollection ! !

!BrowserRequestor methodsFor: 'requests' stamp: 'rr 8/27/2005 15:51'!
getSelectorName
	^ self getBrowser selectedMessageName! !

!BrowserRequestor methodsFor: '*Spy' stamp: 'rr 11/30/2006 19:15'!
getSelectorOrNil
	^ self getBrowser selectedMessageName! !

!BrowserRequestor methodsFor: 'requests' stamp: 'rr 8/27/2005 15:51'!
getSystemCategory
	^ self getBrowser selectedSystemCategoryName ! !

!BrowserRequestor methodsFor: '*Spy' stamp: 'FernandoOlivero 1/13/2011 12:07'!
getSystemCategoryNameOrNil
	| browser |
	browser := self getBrowser.
	( browser respondsTo: #selectedSystemCategoryName)
		ifTrue:[ ^ browser selectedSystemCategoryName ]
		ifFalse:[ ^ nil ].! !

!TextRequestor methodsFor: 'request' stamp: 'rr 8/27/2005 15:42'!
getCurrentText
	"returns the unnacepted text in the text morph" 
	^ self getModel codeTextMorph text! !

!TextRequestor methodsFor: 'request' stamp: 'rr 8/27/2005 15:42'!
getModel
	^ model first! !

!TextRequestor methodsFor: 'accessing' stamp: 'rr 8/27/2005 15:42'!
model: aModel
	model := WeakArray with: aModel! !

Object subclass: #ID
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spy'!

ID class
	instanceVariableNames: 'count'!

ID class
	instanceVariableNames: 'count'!

!ID class methodsFor: 'as yet unclassified' stamp: 'builder 3/1/2007 12:00'!
fromString: s
	^ UUID fromString: s! !

!ID class methodsFor: 'as yet unclassified' stamp: 'builder 3/1/2007 12:12'!
gen
	| id |
	id := count.
	count := count + 1.
	^ id.! !

!ID class methodsFor: 'as yet unclassified' stamp: 'builder 3/1/2007 12:11'!
initialize
	count := 0! !

!Object methodsFor: '*Spy-Services' stamp: 'dgg 11/29/2011 23:25'!
requestor
	^ Requestor default ! !

Object subclass: #SWClassDefinition
	instanceVariableNames: 'instanceVariables classVariables poolVariables className superclassName category'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spy'!

!SWClassDefinition class methodsFor: 'instance creation' stamp: 'rr 1/23/2006 20:47'!
fromEvent: anEvent 
	^self new initializeWithEvent: anEvent! !

!SWClassDefinition class methodsFor: 'instance creation' stamp: 'rr 8/28/2005 14:54'!
fromSource: aString 
	^ self new initializeWithSource: aString! !

!SWClassDefinition methodsFor: 'diffing' stamp: 'rr 8/28/2005 15:27'!
addedClassVariablesIn: newDef
	^ newDef classVariables copyWithoutAll: self classVariables! !

!SWClassDefinition methodsFor: 'diffing' stamp: 'rr 8/28/2005 15:25'!
addedInstanceVariablesIn: newDefinition
	^ newDefinition instanceVariables copyWithoutAll: self instanceVariables! !

!SWClassDefinition methodsFor: 'diffing' stamp: 'rr 8/28/2005 15:28'!
addedPoolVariablesIn: newDef
	^ newDef poolVariables copyWithoutAll: self poolVariables! !

!SWClassDefinition methodsFor: 'diffing' stamp: 'rr 8/28/2005 15:42'!
additionsIn: newDef
	^ self class new 
		initializeIv: (self addedInstanceVariablesIn: newDef)
		cv: (self addedClassVariablesIn: newDef)
		pv: (self addedPoolVariablesIn: newDef) ! !

!SWClassDefinition methodsFor: 'accessing' stamp: 'rr 8/29/2005 10:34'!
allVariables
	^ instanceVariables, classVariables, poolVariables! !

!SWClassDefinition methodsFor: 'accessing' stamp: 'rr 1/23/2006 09:37'!
category
	^category! !

!SWClassDefinition methodsFor: 'accessing' stamp: 'rr 8/28/2005 15:02'!
classVariables
	^ classVariables! !

!SWClassDefinition methodsFor: 'accessing' stamp: 'rr 1/23/2006 09:28'!
defClassName
	^ className! !

!SWClassDefinition methodsFor: 'initialize-release' stamp: 'rr 5/19/2006 11:09'!
initialize
	instanceVariables := #().
	classVariables := #().
	poolVariables := #()! !

!SWClassDefinition methodsFor: 'initialize-release' stamp: 'rr 8/28/2005 16:02'!
initializeIv: a cv: b pv: c 
	instanceVariables := a asArray collect: [:e | e asSymbol].
	classVariables := b asArray collect: [:e | e asSymbol].
	poolVariables := c asArray collect: [:e | e asSymbol]! !

!SWClassDefinition methodsFor: 'initialize-release' stamp: 'rr 4/6/2006 00:16'!
initializeWithEvent: anEvent 
	anEvent source ifNotNil: [self initializeWithSource: anEvent source]
		ifNil: 
			[self 
				initializeIv: #()
				cv: #()
				pv: #().
			className := anEvent classReference classname.
			category := anEvent scnEvent itemCategory.
			anEvent scnEvent item isSymbol 
				ifTrue: [superclassName := #Object]
				ifFalse: [superclassName := (ClassReference for: anEvent scnEvent item superclass) 
						classname]]! !

!SWClassDefinition methodsFor: 'initialize-release' stamp: 'rr 5/19/2006 11:12'!
initializeWithSource: aString 
	| tree notMeta rcvr |
	aString size < 20 ifTrue: [
	Transcript
		cr;
		show: 'initializing with weird source: ';
		cr;
		show: aString].
	tree := RBParser parseExpression: aString.
	tree isMessage 
		ifTrue: 
			[notMeta := tree arguments size = 5.
			notMeta 
				ifTrue: 
					[className := tree arguments first value.
					superclassName := tree receiver name asSymbol.
					self 
						initializeIv: (tree arguments second value findTokens: ' ')
						cv: (tree arguments third value findTokens: ' ')
						pv: (tree arguments fourth value findTokens: ' ').
					category := tree arguments last value]
				ifFalse: 
					[rcvr := tree receiver.
					rcvr isMessage 
						ifTrue: [className := #ProtoObject]
						ifFalse: [className := rcvr name asSymbol].
					superclassName := #ProtoObject.
					self warning: 'something sketchy here'.
					self 
						initializeIv: (tree arguments first value findTokens: ' ')
						cv: Array new
						pv: Array new]]! !

!SWClassDefinition methodsFor: 'accessing' stamp: 'rr 8/28/2005 14:59'!
instanceVariables
	^ instanceVariables! !

!SWClassDefinition methodsFor: 'accessing' stamp: 'rr 8/28/2005 15:05'!
poolVariables
	^ poolVariables! !

!SWClassDefinition methodsFor: 'diffing' stamp: 'rr 8/28/2005 15:45'!
removalsIn: newDef
	^ newDef additionsIn: self! !

!SWClassDefinition methodsFor: 'diffing' stamp: 'rr 8/28/2005 15:31'!
removedClassVariablesIn: newDef
	^ newDef addedClassVariablesIn: self! !

!SWClassDefinition methodsFor: 'diffing' stamp: 'rr 8/28/2005 15:30'!
removedInstanceVariablesIn: newDef
	^ newDef addedInstanceVariablesIn: self! !

!SWClassDefinition methodsFor: 'diffing' stamp: 'rr 8/28/2005 15:33'!
removedPoolVariablesIn: newDef
	^ newDef addedPoolVariablesIn: self! !

!SWClassDefinition methodsFor: 'accessing' stamp: 'rr 1/23/2006 09:33'!
superclassName
	^superclassName! !

!SWClassDefinition methodsFor: 'building' stamp: 'rr 8/30/2005 09:24'!
variablesWithClasses
	^Array 
		with: CMInstanceVariable -> self instanceVariables
		with: CMClassVariable -> self classVariables
		with: CMPoolVariable -> self poolVariables! !

Object subclass: #SWDatedEvent
	instanceVariableNames: 'date author item kind properties string'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spy'!

!SWDatedEvent class methodsFor: 'instance creation' stamp: 'rr 5/15/2006 13:01'!
event: anEvent 
	^ self new event: anEvent! !

!SWDatedEvent methodsFor: 'accessing' stamp: 'rr 2/8/2007 10:20'!
< event
	"some serious weirdness here ... stopRefactoring before startRefactoring ???"
	^ self date = event date ifTrue: [
				self kind = #startRefactoring 
			]
		ifFalse: [self date < event date]! !

!SWDatedEvent methodsFor: 'accessing' stamp: 'rr 2/8/2007 10:21'!
<= event 
	"some serious weirdness here ... stopRefactoring before startRefactoring ???"

	^self date = event date 
		ifTrue: [self kind = #startRefactoring]
		ifFalse: [self date < event date]! !

!SWDatedEvent methodsFor: 'accessing' stamp: 'rr 5/15/2006 15:41'!
author
	^author! !

!SWDatedEvent methodsFor: 'accessing' stamp: 'RomainRobbes 8/3/2010 12:47'!
author: anObject
	author := anObject! !

!SWDatedEvent methodsFor: 'converting' stamp: 'rr 6/7/2006 21:31'!
categoryAdded: anAddedEvent 
	item := anAddedEvent item! !

!SWDatedEvent methodsFor: 'utilities' stamp: 'dgg 1/26/2012 18:32'!
categoryFromDefinition: aClassDefinitionString 
	| category |
	category := aClassDefinitionString
		copyFrom: ( aClassDefinitionString findString: 'category:') + ('category:' size ) 
		to: aClassDefinitionString size.
	^ category trimLeft trimRight  withoutWrappingDoubleQuotes.
	! !

!SWDatedEvent methodsFor: 'utilities' stamp: 'FernandoOlivero 11/24/2010 11:19'!
categoryOf: anEvent 
	^ anEvent itemCategory notNil 
		ifTrue:[ ^ anEvent itemCategory ]
		ifFalse:[ anEvent item isSymbol 
						ifTrue: [ ^ anEvent item]
						ifFalse: [ ^ self categoryFromDefinition: anEvent item definition ] ].! !

!SWDatedEvent methodsFor: 'converting' stamp: 'rr 6/7/2006 21:31'!
categoryRemoved: aRemovedEvent 
	item := aRemovedEvent item! !

!SWDatedEvent methodsFor: 'converting' stamp: 'rr 6/7/2006 21:46'!
categoryRenamed: anAddedEvent 
	item := anAddedEvent newName.
	self properties at: #oldName: put: anAddedEvent oldName! !

!SWDatedEvent methodsFor: 'event handling' stamp: 'RomainRobbes 8/17/2011 14:58'!
classAdded: anAddedEvent 
		| i def |
	i := anAddedEvent item.
	(i isSymbol or: [i isString])
		ifTrue: 
			[def := SWClassDefinition fromSource: string.
			def category ifNil: [^properties := #weirdstuff]. 
			properties at: #definition: put: string.
			properties at: #category: put: def category.
			properties at: #superclass: put: def superclassName.
			properties at: #instvars:
				put: (def instanceVariables collect: [:e | e asString]).
			properties at: #classvars:
				put: (def classVariables collect: [:e | e asString])]
		ifFalse: 
			[properties at: #definition: put: i definition.
			properties at: #category: put: (self categoryOf: anAddedEvent).
			i isTrait ifFalse: [properties at: #superclass: put: i superclass name]
					ifTrue: [properties at: #superclass: put: #Trait].
			properties at: #instvars: put: i instVarNames.
			properties at: #classvars: put: i classVarNames asSortedCollection.
		]! !

!SWDatedEvent methodsFor: 'event handling' stamp: 'dgg 1/19/2012 15:26'!
classCommented: aCommentedEvent 
	aCommentedEvent item isBehavior ifTrue: [
		properties at: #comment put: (aCommentedEvent newComment asString).
		properties at: #oldComment put: (aCommentedEvent oldComment asString) ]
! !

!SWDatedEvent methodsFor: 'event handling' stamp: 'dgg 1/19/2012 15:26'!
classModified: aModifiedClassDefinitionEvent 
	properties at: #oldDefinition put: (aModifiedClassDefinitionEvent oldItem definition).
	self classAdded: aModifiedClassDefinitionEvent! !

!SWDatedEvent methodsFor: 'event handling' stamp: 'rr 5/30/2006 15:34'!
classRecategorized: aRecategorizedEvent 
	properties at: #oldCategory: put: aRecategorizedEvent oldCategory.
	properties at: #newCategory: put: (self categoryOf: aRecategorizedEvent)! !

!SWDatedEvent methodsFor: 'event handling' stamp: 'rr 5/15/2006 13:51'!
classRemoved: aRemovedEvent 
	! !

!SWDatedEvent methodsFor: 'event handling' stamp: 'rr 5/15/2006 14:53'!
classRenamed: aRenamedEvent 
	properties at: #oldName: put: aRenamedEvent oldName.
	properties at: #newName: put: aRenamedEvent newName! !

!SWDatedEvent methodsFor: 'event handling' stamp: 'dgg 1/17/2012 18:00'!
classReorganized: aReorganizedEvent 
	"useless for us"
	"aReorganizedEvent inspect."! !

!SWDatedEvent methodsFor: 'accessing' stamp: 'rr 5/15/2006 15:42'!
date
	^date! !

!SWDatedEvent methodsFor: 'accessing' stamp: 'RomainRobbes 8/3/2010 12:47'!
date: anObject
	date := anObject! !

!SWDatedEvent methodsFor: 'initialize-release' stamp: 'rr 2/8/2007 08:53'!
event: anEvent 
	
	(anEvent isKindOf: AbstractEvent) 
		ifTrue: 
			[anEvent isDoIt ifFalse: [item := anEvent itemReference.
			item ifNotNil: 
					[kind := (anEvent itemKind , anEvent changeKind , ':') asSymbol.
					self perform: kind with: anEvent]]]
		ifFalse: [item := anEvent]! !

!SWDatedEvent methodsFor: 'exporting' stamp: 'dgg 12/16/2011 18:40'!
export
	^ (self exportAsXMLOn: (WriteStream with: '')) contents! !

!SWDatedEvent methodsFor: 'exporting' stamp: 'dgg 12/28/2011 14:03'!
exportAsXMLOn: strm
	| writer a |
	writer := XMLWriter on: strm.
	writer
		enablePrettyPrinting;
		indent;
		writeWith: [:w |
			w tag
				name: (kind copyUpTo: $:);
				attributeAt: 'date' put: date asString;
				attributeAt: 'author' put: author asString;
				with: [
					"w tag: 'source' with: string."
					(item notNil)
						ifTrue: [item isString
							ifTrue: [w tag: 'item' with: item asString]
							ifFalse: [w tag: 'item' with: [item exportOnXMLWriter: w]]].
					"(item isNil or: [item isString])
						ifTrue: [w tag: 'item' with: item asString]
						ifFalse: [w tag: 'item' with: [item exportOnXMLWriter: w]]."
						properties keysAndValuesDo: [:k :v |
							(v isString not and: [v  isCollection])
								ifFalse: [w tag: (k asString copyUpTo: $:) with: v asString]
								ifTrue: [w tag: (k asString copyUpTo: $:) with: v asArray asString] ]]].! !

!SWDatedEvent methodsFor: 'exporting' stamp: 'FernandoOlivero 6/25/2010 11:27'!
exportOn: strm
	| a |
	a := Array 
			with: date asString 
			with:  author asString 
			with: ((item isNil or: [item isString]) 
						ifTrue: [item] 
						ifFalse: [item exportArray] ) 
			with: kind 
			with: (properties keys gather: [:e | | v |
					v := properties at: e.
					Array 
						with: e 
						with: ((v isString not and: [v  isCollection]) 
									ifTrue: [v  asArray] 
									ifFalse: [v ])]) 
			with: string.
	strm nextPutAll: a printString.
	^strm.
	
! !

!SWDatedEvent methodsFor: 'event handling' stamp: 'rr 2/8/2007 08:49'!
expressionDoIt: aDoItEvent 
	self shouldBeImplemented! !

!SWDatedEvent methodsFor: 'recategorization' stamp: 'rr 7/13/2007 11:21'!
fixRecategorizationBug
	| tokens name |
	
	(kind = #methodRecategorized: and: [item name isNil]) 
		ifTrue: [
			Transcript show: 'asf'.
			tokens := string findTokens: ' '.
			tokens first last = $: 
				ifFalse: [item name: tokens first asSymbol]
				ifTrue: [
					name := WriteStream on: ''.
					(tokens pairsCollect: [:a :b | a]) do: [:tk | 
						(tk first isLetter & tk last = $:) ifTrue: [name nextPutAll: tk]
									ifFalse: [item name: name contents asSymbol. ^self]].
					
					item name: name contents asSymbol.			
					]
			]! !

!SWDatedEvent methodsFor: 'initialize-release' stamp: 'rr 7/13/2007 11:13'!
fromSpec: spec 
	
	date := (spec detect: [:e | e key = #date] ifNone: [nil -> DateAndTime epoch]) value.
	author := (spec detect: [:e | e key = #author] ifNone: [nil -> 'unknown']) value.
	kind := (spec detect: [:e | e key = #kind] ifNone: [nil -> nil]) value.
	self event: (spec detect: [:e | e key = #event] ifNone: [nil -> nil]) value.
	self string: (spec detect: [:e | e key = #source] ifNone: [nil -> 'no source']) value.
	self setSourceOrDefinitionOrCommentTo: string.
	! !

!SWDatedEvent methodsFor: 'initialize-release' stamp: 'dgg 1/19/2012 13:23'!
initialize
	date := DateAndTime now.
	author := Spy default getAuthor.
	properties := SmallDictionary new. ! !

!SWDatedEvent methodsFor: 'testing' stamp: 'rr 5/15/2006 15:50'!
isDoIt
	^item isNil! !

!SWDatedEvent methodsFor: 'accessing' stamp: 'rr 2/7/2007 16:18'!
item
	^item! !

!SWDatedEvent methodsFor: 'accessing' stamp: 'RomainRobbes 8/3/2010 12:48'!
item: anObject
	item := anObject! !

!SWDatedEvent methodsFor: 'accessing' stamp: 'rr 5/15/2006 15:42'!
kind
	^kind! !

!SWDatedEvent methodsFor: 'accessing' stamp: 'RomainRobbes 8/3/2010 12:48'!
kind: anObject
	kind := anObject! !

!SWDatedEvent methodsFor: 'event handling' stamp: 'dgg 1/20/2012 13:53'!
methodAdded: anAddedEvent
	( anAddedEvent notNil and:[ 	anAddedEvent isProtocolKnown ] )
		ifTrue: [
			properties
				at: #protocol:
				put: anAddedEvent newProtocol . ].
	properties at: #source:
		put: (
			[anAddedEvent item getSourceCodeClass: anAddedEvent itemClass
				selector: anAddedEvent itemSelector] 
					on: MessageNotUnderstood
					do: [:e | string])! !

!SWDatedEvent methodsFor: 'event handling' stamp: 'dgg 1/20/2012 21:55'!
methodModified: aModifiedEvent
	properties at: #oldSource put: aModifiedEvent oldItem getSource.
	aModifiedEvent isProtocolModified
		ifTrue: [ 
			aModifiedEvent oldProtocol = aModifiedEvent newProtocol
				ifFalse: [ properties at: #oldProtocol put: aModifiedEvent oldProtocol ] ].
	self methodAdded: aModifiedEvent! !

!SWDatedEvent methodsFor: 'event handling' stamp: 'rr 2/13/2009 09:47'!
methodRecategorized: aRecategorizedEvent 
	
	properties at: #protocol: put: aRecategorizedEvent itemProtocol.
	properties at: #oldProtocol: put: aRecategorizedEvent oldCategory! !

!SWDatedEvent methodsFor: 'event handling' stamp: 'rr 5/15/2006 13:25'!
methodRemoved: aRemovedEvent 
	! !

!SWDatedEvent methodsFor: 'accessing' stamp: 'rr 12/1/2006 14:50'!
pAt: k 
	^ self properties at: k! !

!SWDatedEvent methodsFor: 'accessing' stamp: 'rr 11/30/2006 19:33'!
pAt: k put: v
	self properties at: k put: v! !

!SWDatedEvent methodsFor: 'printing' stamp: 'rr 2/12/2009 13:27'!
printOn: aStream
	^ aStream nextPutAll: self printString! !

!SWDatedEvent methodsFor: 'printing' stamp: 'rr 2/12/2009 13:26'!
printString
	^ self kind asString! !

!SWDatedEvent methodsFor: 'accessing' stamp: 'rr 6/8/2006 12:45'!
properties
	^properties! !

!SWDatedEvent methodsFor: 'event handling' stamp: 'rr 2/7/2007 16:24'!
protocolAdded: anAddedEvent 
	self todo: 'implement this message'! !

!SWDatedEvent methodsFor: 'event handling' stamp: 'rr 2/7/2007 16:26'!
protocolRemoved: aRemovedEvent 
	self todo: 'implement'! !

!SWDatedEvent methodsFor: 'initialize-release' stamp: 'rr 5/15/2006 15:23'!
setSourceOrDefinitionOrCommentTo: aString 
	#(definition: comment: source:) do: [:e | (properties includesKey: e)
		ifTrue: [properties at: e put: aString]]! !

!SWDatedEvent methodsFor: 'accessing' stamp: 'rr 12/1/2006 15:06'!
string
	^string! !

!SWDatedEvent methodsFor: 'accessing' stamp: 'rr 7/13/2007 11:09'!
string: anObject 
	string := anObject.
	self fixRecategorizationBug! !

!SWDatedEvent methodsFor: 'accessing' stamp: 'rr 2/7/2007 16:35'!
updateMessageForReceiver: eventProcessor 
	| selector arguments |
	self todo: 'fix pmm bug'.
	selector := WriteStream with: kind asString.
	kind last = $: ifFalse: [selector nextPut: $:].
	arguments := WriteStream with: { item }.
	properties keysAndValuesDo: 
			[:k :v | 
			k = #category ifFalse: [
			selector nextPutAll: k.
			k last = $: ifFalse: [selector nextPut: $:].
			arguments nextPut: v]].
	^MessageSend 
		receiver: eventProcessor
		selector: selector contents asSymbol
		arguments: arguments contents! !

Object subclass: #SWReference
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spy'!

SWReference subclass: #SWClassRef
	instanceVariableNames: 'isMeta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spy'!

!SWClassRef methodsFor: 'export' stamp: 'rr 11/20/2006 13:57'!
exportArray
	^ Array with: #cref with: name with: isMeta asString! !

!SWClassRef methodsFor: 'export' stamp: 'rr 11/20/2006 11:51'!
exportOn: aStream
	aStream nextPut: $(; nextPutAll: 'cref'; space;
		 nextPutAll: name; space; nextPutAll: isMeta asString; nextPut: $).
	^aStream! !

!SWClassRef methodsFor: 'export' stamp: 'dgg 12/28/2011 20:57'!
exportOnXMLWriter: w
	w enablePrettyPrinting.
	w indent.
	w indent.
	w  tag
		name: 'cref';
		attributeAt: 'name' put: name asString;
		attributeAt: 'isMeta' put: isMeta asString;
		write.
	! !

!SWClassRef methodsFor: 'accessing' stamp: 'rr 5/30/2006 12:07'!
isMeta
	^isMeta! !

!SWClassRef methodsFor: 'accessing' stamp: 'RomainRobbes 8/3/2010 12:47'!
isMeta: anObject
	isMeta := anObject! !

!SWClassRef methodsFor: 'accessing' stamp: 'rr 5/15/2006 15:02'!
methodReferenceFor: aSelector
	| ref |
	ref := SWMethodRef new.
	ref name: aSelector.
	ref inClass: name.
	ref isMeta: isMeta.
	^ ref! !

!SWClassRef methodsFor: 'accessing' stamp: 'rr 12/4/2007 17:06'!
nonMeta
	^self copy isMeta: false! !

SWReference subclass: #SWFieldRef
	instanceVariableNames: 'inClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spy'!

!SWFieldRef methodsFor: 'accessing' stamp: 'rr 9/24/2007 12:07'!
= o
	^self class = o class ifTrue: [name = o name & (inClass = o inClass)] ifFalse: [false]! !

!SWFieldRef methodsFor: 'accessing' stamp: 'rr 9/20/2007 15:51'!
classReference
	^ (SWClassRef new) name: inClass; isMeta: false; yourself! !

!SWFieldRef methodsFor: 'accessing' stamp: 'rr 9/24/2007 12:07'!
hash
	^ name hash bitXor: inClass hash! !

!SWFieldRef methodsFor: 'accessing' stamp: 'rr 9/21/2007 16:37'!
inClass
	^ inClass ! !

!SWFieldRef methodsFor: 'accessing' stamp: 'rr 9/20/2007 11:12'!
inClass: className
	inClass := className! !

SWReference subclass: #SWImportRef
	instanceVariableNames: 'importClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spy'!

!SWImportRef methodsFor: 'accessing' stamp: 'rr 9/20/2007 16:44'!
classReference
	^SWClassRef new name: name; isMeta: false; yourself! !

!SWImportRef methodsFor: 'accessing' stamp: 'rr 10/15/2007 11:52'!
importClass: className
	importClass := className asSymbol! !

SWReference subclass: #SWMethodRef
	instanceVariableNames: 'inClass isMeta'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spy'!

!SWMethodRef methodsFor: 'accessing' stamp: 'rr 6/8/2006 14:59'!
= o
	^self class = o class ifTrue: [name = o name & (inClass = o inClass)] ifFalse: [false]! !

!SWMethodRef methodsFor: 'accessing' stamp: 'rr 5/15/2006 15:41'!
classReference
	^ (SWClassRef new) name: inClass; isMeta: isMeta; yourself! !

!SWMethodRef methodsFor: 'export' stamp: 'rr 11/20/2006 13:57'!
exportArray
	^ Array with: #mref with: name with: inClass with: isMeta asString! !

!SWMethodRef methodsFor: 'export' stamp: 'rr 11/20/2006 11:51'!
exportOn: aStream
	aStream nextPut: $(; nextPutAll: 'mref'; space;
		 nextPutAll: name; space; nextPutAll: isMeta asString; space;  nextPutAll: inClass asString; nextPut: $).
	^aStream! !

!SWMethodRef methodsFor: 'export' stamp: 'dgg 12/28/2011 20:57'!
exportOnXMLWriter: w
	w enablePrettyPrinting.
	w indent.
	w indent.
	w tag
		name: 'mref';
		attributeAt: 'name' put: name asString;
		attributeAt: 'inClass' put: inClass asString;
		attributeAt: 'isMeta' put: isMeta asString;
		write.! !

!SWMethodRef methodsFor: 'accessing' stamp: 'rr 6/8/2006 14:59'!
hash
	^ name hash bitXor: inClass hash! !

!SWMethodRef methodsFor: 'accessing' stamp: 'rr 6/8/2006 14:38'!
inClass
	^inClass! !

!SWMethodRef methodsFor: 'accessing' stamp: 'RomainRobbes 8/3/2010 12:48'!
inClass: anObject
	inClass := anObject! !

!SWMethodRef methodsFor: 'accessing' stamp: 'RomainRobbes 8/3/2010 12:48'!
isMeta: anObject
	isMeta := anObject! !

SWReference subclass: #SWPackageRef
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spy'!

!SWReference methodsFor: 'accessing' stamp: 'rr 7/13/2007 10:53'!
name 
	^ name! !

!SWReference methodsFor: 'accessing' stamp: 'RomainRobbes 8/3/2010 12:46'!
name: anObject
	name := anObject! !

!SWReference methodsFor: 'accessing' stamp: 'rr 5/15/2006 15:01'!
nonObsolete
	"remove AnObsolete from name"

	name := (name allButFirst: 10) asSymbol.
	! !

!SWReference methodsFor: 'printing' stamp: 'rr 2/4/2007 09:58'!
printString
	^name ifNil: ['unknow']! !

Object subclass: #SWStack
	instanceVariableNames: 'contextStack'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spy'!

!SWStack class methodsFor: 'as yet unclassified' stamp: 'dgg 12/28/2011 20:47'!
stack: aContextStack
	^ self new stack: aContextStack copy.! !

!SWStack methodsFor: 'as yet unclassified' stamp: 'dgg 1/24/2012 14:01'!
exportOnXMLWriter: w
	[ 
	contextStack
		do: [ :i | 
			w
				tag: 'stackItem'
				with: [ 
					w
						tag: 'receiver' with: i receiver asString;
						tag: 'receiverClass' with: i receiver class name;
						tag: 'sender' with: i sender asString;
						tag: 'senderClass' with: i sender class name;
						tag: 'method' with: i methodSelector asString;
						tag: 'temps'
							with: [ 
									[ 
									i tempScopedNames
										doWithIndex: [ :value :index | 
											| error |
											
											error := [ (i tempAt: index) asString. false ] ifError: [true ].
											error
												ifFalse: [ 
													w
														tag: 'temp'
														with: [ 
															w tag: 'name' with: value.
															w tag: 'value' with: (i tempAt: index) asString ] ]
												ifTrue: [ w tag: 'error' with: 'error printing temp data' ] ] ]
										ifError: [ w tag: 'error' with: 'error printing temps data' ] ].
					i isClosureContext
						ifTrue: [ w tag: 'closure' with: i closure asString ] ] ] ]
		ifError: [ w tag: 'Error' with: 'error printing stack data' ]! !

!SWStack methodsFor: 'as yet unclassified' stamp: 'dgg 12/28/2011 20:07'!
stack: aContextStack
	contextStack := aContextStack! !

Object subclass: #Spy
	instanceVariableNames: 'events id saveBar uploads file lastAuthor uploadProcess'
	classVariableNames: 'SpyServer'
	poolDictionaries: ''
	category: 'Spy'!

Spy class
	instanceVariableNames: 'default savetime uploadNumber'!

!Spy commentStamp: '<historical>' prior: 0!
I'm spying you!!!

Spy class
	instanceVariableNames: 'default savetime uploadNumber'!

!Spy class methodsFor: 'as yet unclassified' stamp: 'dgg 1/20/2012 14:29'!
aspectList
	^ (OrderedCollection new)
		add: ClassProtocolAspect;
		add: ClipboardClassAspect;
		add: DebuggerAspect;
		add: DoitAspect;
		add: GetSourceAspect;
		add: InspectVariablesAspect;
		add: KeyboardActivityAspect;
		add: MCRepositoryAspect;
		add: MCVersionLoaderClassAspect;
		add: MCWorkingCopyBrowserAspect;
		add: MenuAspect;
		add: UnhandledErrorAspect;
		add: WindowEventsAspect;
		yourself! !

!Spy class methodsFor: 'accessing' stamp: 'rr 5/8/2008 19:11'!
default
	^ default ifNil: [default := self new].! !

!Spy class methodsFor: 'accessing' stamp: 'dgg 1/3/2012 21:04'!
initialize
	super initialize.
	self spyServer: 'http://localhost:8080' asZnUrl.
	"self install"! !

!Spy class methodsFor: 'accessing' stamp: 'dgg 11/29/2011 23:32'!
install
	self default install.
	Smalltalk addToShutDownList: self.
	Smalltalk addToStartUpList: self.
	self installAspects.
	SystemChangeNotifier uniqueInstance notify: self ofAllSystemChangesUsing: #spyEvent:.! !

!Spy class methodsFor: 'accessing' stamp: 'dgg 1/20/2012 14:33'!
installAspects
	"ClipboardClassAspect install.
	MCRepositoryAspect install.
	MCVersionLoaderClassAspect install.
	MCWorkingCopyBrowserAspect install.
	UnhandledErrorAspect install.
	GetSourceAspect install.
	DoitAspect install.
	InspectVariablesAspect install.
	WindowEventsAspect install.
	DebuggerAspect install.
	KeyboardActivityAspect install.
	MenuAspect install.
	ClassProtocolAspect install."
	self aspectList do:[:asp |
		asp install] displayingProgress: 'Installing Aspects'.! !

!Spy class methodsFor: 'accessing' stamp: 'rr 2/21/2007 10:23'!
logNavigationFrom: announcement
	^ self default logNavigationFrom: announcement requestor! !

!Spy class methodsFor: 'accessing' stamp: 'rr 1/16/2007 09:19'!
newFor: aBlock 
	| spy |
	spy := self new.
	aBlock value: spy.
	^spy events isEmpty ifTrue: [nil] ifFalse: [(spy events first) date: nil; yourself ]! !

!Spy class methodsFor: 'accessing' stamp: 'rr 9/5/2006 14:45'!
shutDown
	self default shutDown! !

!Spy class methodsFor: 'accessing' stamp: 'rr 11/30/2006 18:35'!
spyEvent: e 
	self default spyEvent: e ! !

!Spy class methodsFor: 'as yet unclassified' stamp: 'dgg 1/3/2012 20:56'!
spyServer
	^ SpyServer! !

!Spy class methodsFor: 'as yet unclassified' stamp: 'dgg 1/3/2012 21:01'!
spyServer: aZnUrl
	SpyServer := aZnUrl! !

!Spy class methodsFor: 'accessing' stamp: 'rr 11/30/2006 11:38'!
spyVersion
	^ '002'! !

!Spy class methodsFor: 'accessing' stamp: 'rr 9/5/2006 14:45'!
startUp: resuming
	self default startUp: resuming! !

!Spy class methodsFor: 'accessing' stamp: 'dgg 12/16/2011 15:48'!
uninstall
	"self default uninstall."

	Smalltalk removeFromShutDownList: self.
	Smalltalk removeFromStartUpList: self.
	self uninstallAspects.
	SystemChangeNotifier uniqueInstance noMoreNotificationsFor: self.
	self default uninstall.! !

!Spy class methodsFor: 'accessing' stamp: 'dgg 1/20/2012 14:33'!
uninstallAspects
	"ClipboardClassAspect uninstall.
	MCRepositoryAspect uninstall.
	MCVersionLoaderClassAspect uninstall.
	MCWorkingCopyBrowserAspect uninstall.
	UnhandledErrorAspect uninstall.
	GetSourceAspect uninstall.
	DoitAspect uninstall.
	InspectVariablesAspect uninstall.
	WindowEventsAspect uninstall.
	DebuggerAspect uninstall.
	KeyboardActivityAspect uninstall.
	MenuAspect uninstall.
	ClassProtocolAspect uninstall."
	self aspectList do:[:asp |
		asp uninstall] displayingProgress: 'Uninstalling Aspects'.! !

!Spy class methodsFor: 'as yet unclassified' stamp: 'dgg 1/3/2012 21:12'!
uploadUrl
	^ (SpyServer copy) addPathSegment: 'upload-api'! !

!Spy methodsFor: 'event handling' stamp: 'dgg 1/19/2012 15:13'!
addEvent: event 
	| dated |
	dated := SWDatedEvent new fromSpec: event.
	"events add: dated."
	^ dated! !

!Spy methodsFor: 'file saving' stamp: 'RomainRobbes 12/3/2009 18:05'!
changeDirectoryFtp: ftp 
	| userName users |
	userName := Author fullName.
	ftp changeDirectoryTo: 'uploads'.
	ftp changeDirectoryTo: 'mkdirs'.
	ftp changeDirectoryTo: 'spy', self class spyVersion.
	users := (ftp getDirectory findTokens: Character cr asString) collect: [:e | (e findTokens: ' ') last].
	(users includes: userName) ifFalse: [ftp makeDirectory: userName].
	ftp changeDirectoryTo: userName.! !

!Spy methodsFor: 'initialize-release' stamp: 'dgg 1/16/2012 18:45'!
closeAndCompressLogFile
	[file notNil
		ifTrue: [ 
			file
				cr;
				nextPutAll: '</root>'.
			file close.
			GZipWriteStream compressFile: file fullName.
			(FileDirectory default directoryNamed: 'activity-log') deleteFileNamed: file fullName.
			file := nil ]] on: Error do: [Transcript show: 'Error compressing and closing file!!'; cr]! !

!Spy methodsFor: 'event handling' stamp: 'dgg 1/19/2012 13:28'!
createAuthoredEvent: e
	| event |
	event := self eventOfKind: e class changeKind.
	event add: #event -> e.
	event add: #id -> ID gen asString.
	event add: #author -> self getAuthor.
	^ event! !

!Spy methodsFor: 'file saving' stamp: 'dgg 1/16/2012 18:52'!
createUploadProcess
	uploadProcess
		ifNil: [ uploadProcess := [ self uploadFilesProcess ] forkNamed: 'SpyUploadProcess' ]
		ifNotNilDo: [ :p | 
			p isTerminated
				ifFalse: [ p terminate ].
			uploadProcess := nil.
			self createUploadProcess ]! !

!Spy methodsFor: 'file saving' stamp: 'dgg 1/20/2012 21:50'!
createXMLLogFile
	| imName uuid fileName dir f |
	imName := SmalltalkImage current imageName.
	imName := FileDirectory baseNameFor: (FileDirectory localNameFor: imName).
	uuid := UUID new asString.
	"fileName := ((DateAndTime now asString copyReplaceAll: ':' with: '-') allButLast: 6) , '-' , Author fullName , '-' , imName , '-spy.xml'."
	fileName := uuid,'-spy.xml'.
	dir := FileDirectory default directoryNamed: 'activity-log'.
	dir assureExistence.
	f := dir forceNewFileNamed: fileName.
	(XMLWriter on: f)
		enablePrettyPrinting;
		xml;
		comment: 'Spy log file'.
	f cr; nextPutAll: '<root ', 'os="',OSPlatform platformName asString,'" osVersion="', (SmalltalkImage current platform osVersion),'" vm="', (SmalltalkImage current platform vmVersion),'" image="',(SystemVersion current imageVersionString),'" imgname="', imName,'">'; cr.
	^ f
		! !

!Spy methodsFor: 'refactoring support' stamp: 'FernandoOlivero 11/24/2010 11:01'!
detectRefactoring
	( Smalltalk globals hasClassNamed:#Refactoring) ifTrue:[
		| class |
		class := Smalltalk globals classNamed: #Refactoring.
		(class sourceCodeAt: #execute) size < 90 ifTrue: [ 
		class compileSilently: self refactoringExecuteString classified: 'transforming']]! !

!Spy methodsFor: 'as yet unclassified' stamp: 'dgg 1/16/2012 18:49'!
endRefactoring: ref 
	self saveEvent: (self addEvent: ((self eventOfKind: #endRefactoring)
				add: #event -> ref name;
				yourself))! !

!Spy methodsFor: 'event handling' stamp: 'rr 11/20/2006 14:36'!
eventOfKind: t 
	| event |
	event := OrderedCollection new.
	event add: #kind -> t.
	event add: #date -> DateAndTime now asString.
	^ event! !

!Spy methodsFor: 'accessing' stamp: 'rr 11/14/2006 10:47'!
events
	^ events! !

!Spy methodsFor: 'accessing' stamp: 'RomainRobbes 8/3/2010 12:54'!
events: anObject
	events := anObject! !

!Spy methodsFor: 'file saving' stamp: 'dgg 12/16/2011 18:43'!
file
	file ifNil: [file := self createXMLLogFile ].
	^ file! !

!Spy methodsFor: 'file saving' stamp: 'rr 11/30/2006 14:01'!
fileName
	^ 'changelog--', self id asString, '.spy'! !

!Spy methodsFor: 'event handling' stamp: 'rr 9/5/2006 14:38'!
fillData: data classEvent: event savedEvent: e 
	e isAdded ifTrue: [data add: #source -> e item definition].
	data add: #category -> event itemCategory.
	e item: e item name kind: e itemKind.
	e isModified 
		ifTrue: 
			[data add: #source -> event item definition.
			data add: #source -> event oldItem definition.
			e oldItem: e oldItem name].
	e isCommented 
		ifTrue: 
			[data add: #comment 
						-> event item theNonMetaClass organization classComment asString]! !

!Spy methodsFor: 'event handling' stamp: 'dgg 1/26/2012 18:16'!
fillData: data methodEvent: event savedEvent: e
	"do something for compiledmethods whose methodreference is nil.
	first count them."
	data add: #source -> ([ event item getSource asString ] on: Error do: [ 'noSource' ]).
	data add: #category -> ([event item methodReference ifNotNilDo: [ :mr | mr category ] ifNil: [ nil ]] on: Error do: [nil]).
	e item: ([e item methodReference ifNotNilDo: [ :mr | mr asString ] ifNil: [ nil ]] on: Error do: [nil]) kind: e itemKind.
	e isModified
		ifTrue: [ 
			data add: #oldSource -> event oldItem getSource asString.
			e oldItem methodReference ifNotNilDo: [ :mr | e oldItem: mr asString ] ifNil: [ e oldItem: nil ] ]! !

!Spy methodsFor: 'as yet unclassified' stamp: 'dgg 1/19/2012 13:56'!
getAuthor
	(UIManager default isKindOf: NonInteractiveUIManager)
		ifFalse: [^ Author fullName]
		ifTrue: [
			^ Author fullNamePerSe isEmptyOrNil 
				ifTrue: [
					lastAuthor isEmptyOrNil
						ifTrue: ['unknown']
						ifFalse: [lastAuthor]]
				ifFalse: [Author fullNamePerSe]]! !

!Spy methodsFor: 'accessing' stamp: 'rr 9/6/2006 10:21'!
id
	^ id ifNil: [id := UUID new]! !

!Spy methodsFor: 'initialize-release' stamp: 'rr 11/23/2006 15:44'!
initialize
	super initialize.
	events := OrderedCollection new.
	! !

!Spy methodsFor: 'initialize-release' stamp: 'rr 11/24/2006 13:55'!
install
	self detectRefactoring.! !

!Spy methodsFor: 'event types' stamp: 'dgg 1/11/2012 01:22'!
logEventFromSpec: spec kind: aKind
	self logEventFromSpec: spec kind: aKind item: nil source: nil! !

!Spy methodsFor: 'event types' stamp: 'dgg 1/11/2012 01:22'!
logEventFromSpec: spec kind: aKind item: anItem
	self logEventFromSpec: spec kind: aKind item: anItem source: nil! !

!Spy methodsFor: 'event types' stamp: 'dgg 1/19/2012 13:27'!
logEventFromSpec: spec kind: aKind item: anItem source: aSource
	| event dated |
	event := self eventOfKind: aKind.
	event add: #id -> ID gen asString.
	event add: #author -> self getAuthor.
	dated := self addEvent: event.
	anItem ifNotNilDo: [ :it | dated item: it ].
	aSource ifNotNilDo: [ :sc | dated string: sc ].
	spec keysAndValuesDo: [ :k :v | dated properties at: k put: v ].
	self saveEvent: dated! !

!Spy methodsFor: 'event types' stamp: 'dgg 12/28/2011 12:59'!
logNavigationFrom: requestor
	| event dated |
	"requestor getClassNameOrNil ifNil: [^ self].
	event := (self eventOfKind: #navigate)
				add: #event -> #navigate; yourself.
	dated := self addEvent: event.
	dated properties at: #class put: requestor getClassNameOrNil.
	dated properties at: #selector put: requestor getSelectorOrNil.
	dated properties at: #browser put: requestor getBrowserId.
	dated properties at: #browserType put: requestor getBrowser class name.
	self saveEvent: dated"
	(requestor at: #class) ifNil: [^ self].
	event := (self eventOfKind: #navigate).
				"add: #event -> #navigate; yourself."
	dated := self addEvent: event.
	dated properties at: #class put: (requestor at: #class).
	dated properties at: #selector put: (requestor at: #selector).
	dated properties at: #browser put: (requestor at: #browser).
	dated properties at: #browserType put: (requestor at: #browserType).
	requestor at: #contentSelection ifPresent: [:sel | dated properties at: #selection put: sel].
	"dated properties at: #author put: Author fullName."
	self saveEvent: dated! !

!Spy methodsFor: 'event types' stamp: 'dgg 12/28/2011 13:01'!
logShutdown
	| event  |
	
	
	event := (self eventOfKind: #shutDown).
				"add: #event -> #shutDown; yourself."
	self saveEvent: (self addEvent: event).
	! !

!Spy methodsFor: 'event types' stamp: 'dgg 12/28/2011 13:01'!
logStartup
	| event  |
	
	
	event := (self eventOfKind: #startUp).
				"add: #event -> #startUp; yourself."
	self saveEvent: (self addEvent: event).
! !

!Spy methodsFor: 'refactoring support' stamp: 'rr 9/6/2006 09:20'!
refactoringExecuteString
^
'execute
	self primitiveExecute.
	Smalltalk at: #Spy ifPresent: [:spy | spy default startRefactoring: self].
	RefactoringManager instance addRefactoring: self.
	Smalltalk at: #Spy ifPresent: [:spy | spy default endRefactoring: self].'! !

!Spy methodsFor: 'file saving' stamp: 'cdlm 6/18/2008 22:11'!
save
	uploads := self uploads + 1.
	"(self confirm: 'Do you want SpyWare to send its data now?')
		ifTrue: ['SpyWare is sending data' displayProgressAt: Display center from: 1 to: 7 during: [:bar |
					saveBar := bar.
					self saveFile.
					self sendData.]]"! !

!Spy methodsFor: 'startup/shutdown' stamp: 'dgg 1/8/2012 02:32'!
saveEvent: ev
	[ev exportAsXMLOn: self file.
	self file cr] 
		on: Error 
		do: [self inform: 'error in Spy>>#saveEvent:'.
			self closeAndCompressLogFile]
	"ev exportAsXMLOn: self file.
	self file cr."! !

!Spy methodsFor: 'startup/shutdown' stamp: 'dgg 1/19/2012 13:38'!
shutDown
	self logShutdown.
	lastAuthor := Author fullName.
	self closeAndCompressLogFile.
	"(UIManager default confirm: 'upload logs to server')
		ifTrue: [
			self uploadAllFilesToServer]"! !

!Spy methodsFor: 'event types' stamp: 'dgg 1/18/2012 19:18'!
spyEvent: event 
	| data e dated | 
	e := event copyForLongTermStorage.
	data := self createAuthoredEvent: event.
	e itemKind = AbstractEvent methodKind 
		ifTrue: 
			[self 
				fillData: data
				methodEvent: event
				savedEvent: e].
	e itemKind = AbstractEvent classKind 
		ifTrue: 
			[self 
				fillData: data
				classEvent: event
				savedEvent: e].
	e itemClass ifNotNilDo: [:c | e itemClass: c name].
	"e isDoIt ifTrue: [e context: nil]."
	e isDoIt ifTrue: [^self].
	e isReorganized ifTrue: [^self].
	(e isCommented and: [e newComment isNil]) ifTrue: [^self].
	dated := self addEvent: data.
	self saveEvent: dated! !

!Spy methodsFor: 'as yet unclassified' stamp: 'dgg 1/16/2012 18:48'!
startRefactoring: ref 
	self saveEvent: (self addEvent: ((self eventOfKind: #startRefactoring)
				add: #event -> ref name;
				yourself))! !

!Spy methodsFor: 'startup/shutdown' stamp: 'dgg 1/19/2012 13:18'!
startUp: resuming
	"resuming ifTrue: [
		dirty ifTrue: [self reset].
		session := nil]."

	"Author fullName: author."

	self logStartup.
	self detectRefactoring.
	self createUploadProcess! !

!Spy methodsFor: 'initialize-release' stamp: 'dgg 1/16/2012 19:02'!
uninstall
	self closeAndCompressLogFile.
	uploadProcess ifNotNilDo: [:p |
		p isTerminated ifFalse: [p terminate].
		uploadProcess := nil].
	(UIManager default confirm: 'upload logs to server')
		ifTrue: [
			self uploadAllFilesToServer]! !

!Spy methodsFor: 'file saving' stamp: 'rr 11/30/2006 13:27'!
uniqueFileName
	^ DateAndTime now asString, '--', self id asString, '--', self uploads asString, '.spy', '.', self class spyVersion, '.gz'! !

!Spy methodsFor: 'file saving' stamp: 'dgg 1/6/2012 01:31'!
uploadAllFilesToServer
	| dir |
	dir := FileDirectory default directoryNamed: 'activity-log'.
	(dir matchingEntries: '*.gz') do: [:each |
		(self uploadFileToServer: each fullName) contents asString = 'OK'
			ifTrue: [dir deleteFileNamed: each name]]! !

!Spy methodsFor: 'file saving' stamp: 'dgg 1/19/2012 13:37'!
uploadFileToServer: aFilePath
	|  fileStream entity fileEntity part hash |
	fileStream := (FileStream fileNamed: aFilePath) binary.
	hash := MD5 new hashStream: fileStream contents readStream.
	entity := ZnMultiPartFormDataEntity new.
	fileEntity := ZnEntity with: fileStream contentsOfEntireFile type: fileStream mimeTypes first asString.
	part := ZnMimePart fieldName: 'file' fileName: fileStream localName entity: fileEntity.
	entity addPart: part.
	entity addPart: (ZnMimePart fieldName: 'author' value: (self getAuthor)).
	entity addPart: (ZnMimePart fieldName: 'md5' value: hash).
	entity addPart: (ZnMimePart fieldName: 'language' value: 'Smalltalk').
	^ [ZnClient post: Spy uploadUrl data: entity] on: Error do: ['fail'].
	! !

!Spy methodsFor: 'file saving' stamp: 'dgg 1/19/2012 15:32'!
uploadFilesProcess
	| dir files |
	"[SmalltalkImage current isInteractive] whileFalse: [
		(Delay forSeconds: 60) wait]."
	dir := FileDirectory default directoryNamed: 'activity-log'.
	[(dir matchingEntries: '*.gz') size > 0] whileTrue: [
		self uploadAllFilesToServer.
		(Delay forSeconds: (60 * 15)) wait ] ! !

!Spy methodsFor: 'accessing' stamp: 'rr 11/30/2006 11:51'!
uploads
	^ uploads ifNil: [uploads := 0]! !

!Spy methodsFor: 'file saving' stamp: 'rr 11/30/2006 10:52'!
zippedFileName
	^ self fileName , '.gz'! !
ID initialize!
Spy initialize!
